# Unit Statistics Mod
#  by
# Teg_Navanis
# based on Kill List Mod by Roger Bacon

from CvPythonExtensions import *
import CvUtil
import PyHelpers
import Popup as PyPopup
import CvConfigParser
import RandomNameUtils
import NexusNameUtils
import Numsort


#######SD Tool Kit#######

import SdToolKitAdvanced
sdEntityInit   = SdToolKitAdvanced.sdEntityInit
sdEntityExists = SdToolKitAdvanced.sdEntityExists
sdEntityWipe   = SdToolKitAdvanced.sdEntityWipe
sdGetVal       = SdToolKitAdvanced.sdGetVal
sdSetVal       = SdToolKitAdvanced.sdSetVal

sdObjectInit      = SdToolKitAdvanced.sdObjectInit
sdObjectWipe      = SdToolKitAdvanced.sdObjectWipe
sdObjectExists    = SdToolKitAdvanced.sdObjectExists
sdObjectGetVal    = SdToolKitAdvanced.sdObjectGetVal
sdObjectSetVal    = SdToolKitAdvanced.sdObjectSetVal

############################
			
# globals
gc = CyGlobalContext()
PyPlayer = PyHelpers.PyPlayer
PyInfo = PyHelpers.PyInfo
localText = CyTranslator()

COMBATCOUNT = "CombatCount"
BODYCOUNT = "BodyCount"
BATTLECOUNT = "BattleCount"
ATTACK = "Attack"
DEFENCE = "Defence"
AIRATTACK = "AirAttack"
AIRDEFENCE = "AirDefence"
AIRSTRIKE = "AirStrike"
LIST = "List"
TYPENUMBER = "TypeNumber"
STARTDATE = "StartDate"
STARTTURN = "StartTurn"
MOVEMENT_COUNTER = "MoveCounter"
CARGO_COUNTER = "CargoCounter"
MOVEMENT_COUNTER_ENEMY = "MoveCounterEnemy"
PLOT= "Plot"
WARP = "Warp"
TRANSPORT = "Transport"
DAMAGETYPE = ["DamageInflicted", 
			  "DamageInflictedAttacking", 
			  "DamageInflictedDefending", 
			  "DamageSuffered", 
			  "DamageSufferedAttacking", 
			  "DamageSufferedDefending",
			  "CollateralDamageInflicted",
			  "CollateralDamageSuffered",
			  "AirStrikeDamageInflicted",
			  "AirStrikeDamageSuffered"]
DAMAGESTATS = "DamageStats"
EXPERIENCE = "Experience"
LOSTNAMESLIST = "LostNamesList"
BESTODDS = "BestOdds"
ODDSDATA = "OddsData"
AVERAGEODDS = "AverageOdds"
AVERAGEODDSHIGHEST = "AverageOddsHighest"
AVERAGEODDSLOWEST = "AverageOddsLowest"
LIFEODDS = "LifeOdds"
GOODIES = "Goodies"
TURNINFORMATION = "TurnInformation"
TOTALTURNSFORTIFIED = "TotalTurnsFortified"
MAXTURNSFORTIFIED = "MaxTurnsFortified"
CAPTURECOUNT = "CaptureCount"

HighScoreTypes = {				
						  		BODYCOUNT: 0, 
						  		BATTLECOUNT: 0,
								DAMAGETYPE[0]: 0,
								DAMAGETYPE[1]: 0,
								DAMAGETYPE[2]: 0,
								DAMAGETYPE[3]: 0,
								DAMAGETYPE[4]: 0,
								DAMAGETYPE[5]: 0,
								DAMAGETYPE[6]: 0,
								DAMAGETYPE[7]: 0,
								DAMAGETYPE[8]: 0,
								DAMAGETYPE[9]: 0,
								MOVEMENT_COUNTER: 0, 
								CARGO_COUNTER: 0,
						  		WARP: 0,
						  		STARTTURN: 6000, 
						  		BESTODDS: 101,
						  		AVERAGEODDSHIGHEST: -1,
						  		AVERAGEODDSLOWEST: 101,
						  		LIFEODDS: 101,
						  		EXPERIENCE: 0,
						  		TOTALTURNSFORTIFIED: 0,
						  		MAXTURNSFORTIFIED: 0,
						  		}
						  
			
UnitStatsData = {
							COMBATCOUNT: {ATTACK: [0, 0, 0, 0], DEFENCE: [0, 0, 0, 0], AIRATTACK: [0, 0, 0], AIRDEFENCE: [0, 0, 0], AIRSTRIKE: [0, 0]},
							TURNINFORMATION: [0, 0, 0],
							STARTDATE: 0,
							STARTTURN: 0,
							CARGO_COUNTER: 0,
							MOVEMENT_COUNTER: 0,
							PLOT: [0, 0],
							WARP: 0,
							TRANSPORT: 0,
							DAMAGESTATS: [0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
							BESTODDS: -1,
							EXPERIENCE: 0,
							AVERAGEODDS: -1,
							LIFEODDS: 100,
							ODDSDATA: [0, 0, "", 101],
				 			CAPTURECOUNT: 0,
							LIST: "" }

PlayerStatsData = {
							COMBATCOUNT: {ATTACK: [0, 0, 0, 0], DEFENCE: [0, 0, 0, 0], AIRATTACK: [0, 0, 0], AIRDEFENCE: [0, 0, 0], AIRSTRIKE: [0, 0]},
							TURNINFORMATION: [0, 0, 0],
							CARGO_COUNTER: 0,
							MOVEMENT_COUNTER: 0,
							WARP: 0,
							TRANSPORT: 0,
							DAMAGESTATS: [0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
							EXPERIENCE: 0,
							CAPTURECOUNT: 0,
							GOODIES: 0  }

# Change this to either enable or disable tracking of your currently best units.
# Default value is true
g_bTrackHighScore = true


# Change this to either enable or disable goody received tracking.
# Default value is true
g_bTrackGoodyReceived = true


# Change this to either enable or disable turn information tracking (amount of turns fortified)
# Default value is true
g_bTrackTurnInformation = true

# Change this to show or hide the number of combats, units killed, units lost and retreats.
# Default value is true
g_bShowCombatCount = true

# Change this to show or hide the unit creation date.
# 0 = no service information
# 1 = "Turns in service: 8 (320 years)"
# 2 = "Years in service: 320 (8 turns)"
# 3 = "Turns in service: 8
# 4 = "Years in service: 320
# Default value is 1
g_iUnitServiceInformation = 1


# Change this to track the distance a unit has moved.
# Default value is true
g_bTrackMovement = true

# Change this to show or hide the unit event log
# Default value is true
g_bShowUnitEventLog = true

# Change this to display the turn information in the unit events log
# Default value is true
g_bShowLogTurnInformation = true

# Change this to display the year information in the unit events log
# Default value is true
g_bShowLogDateInformation = true

# Change this to switch the order that the turn and year for the logged event 
# are displayed. For example if set to false then a unit that was created in 
# turn 0 and year 4000BC would be displayed as "Turn 0 (4000BC): <Unit type> 
# created".
# Default value is true
g_bShowLogTurnInformationFirst = true

# Change this to display the damage your unit has inflicted/suffered.
# Default value is true
g_bShowDamageInformation = true

# Change this to show or hide combat odds statistics.
# Default value is true
g_bShowOdds = true

# Change this to show or hide unit experience.
# Default value is true
g_bShowExperience = true

# Change this to either enable or disable unit statistics for non-combatants (settlers, workers, missionaries, great people)
# Default value is true
g_bTrackNonCombatants = true

# Change this to either enable or disable unit statistics for all players (beta, not working)
# Default value is false
g_bTrackAllPlayers = false

# Change this to either enable or disable the display of other players' unit statistics 
# Leave disabled if you don't want any additional information about enemy units
# Default value is false
g_bShowAllPlayers = false

# If this is enabled, all players share one high score list (g_bTrackAllPlayers required for this to have effect)
# Default value is false
g_bGlobalHighScore = false

# Change this for different name generators.
# 0 = no unit naming (use this only when you also use the Unit Statistics CvGameCoreDLL!)
# 1 = Warrior 1, Warrior 2, Axeman 1, Axeman 2
# 2 = Random Name Generator by TheLopez
# 3 = Nexus naming 1st Army 1st Corp 1st Div
# Default value is 1
g_iUnitNaming = 1

# Change this to enable or disable the recycling of dead unit's names.
# Default value is true
g_bUnitNameRecycling = true

class UnitStatisticsUtils:

	def __init__(self):

		global g_bShowCombatCount
		global g_iUnitServiceInformation
		global g_bTrackMovement 
		global g_bShowUnitEventLog 
		global g_bShowLogTurnInformation 
		global g_bShowLogDateInformation 
		global g_bShowLogTurnInformationFirst 
		global g_bShowDamageInformation
		global g_bShowOdds
		global g_iUnitNaming		
		global g_bUnitNameRecycling
		global g_bTrackNonCombatants 
		global g_bTrackHighScore
		global g_bTrackTurnInformation
		global g_bTrackAllPlayers
		global g_bTrackGoodyReceived
		global g_bShowExperience
		global g_bGlobalHighScore
		global g_ShowAllPlayers
		
		# Load the Unit Statistics Mod Config INI file containing all of the configuration information		
		config = CvConfigParser.CvConfigParser("Unit Statistics Mod Config.ini")
		
		# If we actually were able to open the "Unit Statistics Mod Config.ini" file then read in the values.
		# otherwise we'll keep the default values that were set at the top of this file.
		if(config != None):
			g_bTrackHighScore = config.getboolean("Unit Statistics Mod", "Track Unit High Score", true)
			g_bTrackTurnInformation = config.getboolean("Unit Statistics Mod", "Track Turn Information", true)
			g_bTrackGoodyReceived = config.getboolean("Unit Statistics Mod", "Track Goody Received", true)
			g_bShowCombatCount = config.getboolean("Unit Statistics Mod", "Show Combat Count", true)
			g_iUnitServiceInformation = config.getint("Unit Statistics Mod", "Show Unit Service Information", 1)
			g_bTrackMovement = config.getboolean("Unit Statistics Mod", "Track Unit Movement", false)
			g_bShowUnitEventLog = config.getboolean("Unit Statistics Mod", "Show Unit Event Log", true)
			g_bShowLogTurnInformation = config.getboolean("Unit Statistics Mod", "Show Log Turn Information", true)
			g_bShowLogDateInformation = config.getboolean("Unit Statistics Mod", "Show Log Date Information", true)
			g_bShowLogTurnInformationFirst = config.getboolean("Unit Statistics Mod", "Show Log Turn Information First", true)			
			g_bShowDamageInformation = config.getboolean("Unit Statistics Mod", "Show Damage Information", true)
			g_bShowOdds = config.getboolean("Unit Statistics Mod", "Show Odds", true)
			g_iUnitNaming = config.getint("Unit Statistics Mod", "Unit Naming", 1)
			g_bUnitNameRecycling = config.getboolean("Unit Statistics Mod", "Unit Name Recycling", true)
			g_bTrackNonCombatants = config.getboolean("Unit Statistics Mod", "Track Non-Combat Units", true)
			g_bTrackAllPlayers = config.getboolean("Unit Statistics Mod", "Track All Players", false)
			g_bShowExperience = config.getboolean("Unit Statistics Mod", "Show Experience", true)
			g_bShowAllPlayers = config.getboolean("Unit Statistics Mod", "Show All Players", false)
			g_bGlobalHighScore = config.getboolean("Unit Statistics Mod", "Global High Score", false)


		if (not g_bGlobalHighScore and g_bTrackAllPlayers):
			PlayerStatsData["HighscoresHoF"] = HighScoreTypes
			PlayerStatsData["Highscores"] =  HighScoreTypes
			PlayerStatsData["HighscoreUnits"] = HighScoreTypes


	def	sdObjectSetDictVal(self, mod, object, dict, var, val):
		if (sdObjectExists(mod, object) == false):
			sdObjectInit(mod, object, PlayerStatsData)
		dictionary = sdObjectGetVal(mod, object, dict)
		dictionary[var] = val
		sdObjectSetVal(mod, object, dict, dictionary)

	def	sdObjectGetDictVal(self, mod, object, dict, var):
		if (sdObjectExists(mod, object) == false):
			sdObjectInit(mod, object, PlayerStatsData)
		dictionary = sdObjectGetVal(mod, object, dict)
		val = dictionary[var]
		return val

	#checks highscores for all units.
	def	checkHighScoresAllUnits(self, htype, iPlayer):

		
		if (not g_bTrackHighScore):
			return

		objPlayer = gc.getPlayer(iPlayer)
		unitList = []
		
		if (g_bGlobalHighScore and g_bTrackAllPlayers):
			for iPlayer in range(gc.getGame().countCivPlayersEverAlive()):
				pyPlayer = PyPlayer(iPlayer)
				unitList = unitList + pyPlayer.getUnitList()	
		else:
			unitList = PyPlayer(iPlayer).getUnitList()

		if (g_bGlobalHighScore or not g_bTrackAllPlayers):
			#this entity stores the high score values
			if (sdEntityExists("UnitStats", "Highscores") == false):
				sdEntityInit("UnitStats", "Highscores", HighScoreTypes)
		
			#this entity stores the high score unit IDs
			if (sdEntityExists("UnitStats", "HighscoreUnits") == false):
				sdEntityInit("UnitStats", "HighscoreUnits", HighScoreTypes)
			
			#this entity stores the hall of fame high scores (high scores including dead units)	
			if (sdEntityExists("UnitStats", "HighscoresHoF") == false):
				sdEntityInit("UnitStats", "HighscoresHoF", HighScoreTypes)

			sdSetVal("UnitStats", "HighscoreUnits", htype, -1)
			

		else:	
			#this entity stores the high score values
			if (sdObjectExists("UnitStats", objPlayer) == false):
				sdObjectInit("UnitStats", objPlayer, PlayerStatsData)

			self.sdObjectSetDictVal("UnitStats", objPlayer, "HighscoreUnits", htype, -1)
	

		if (len(unitList) == 0):
			print "no units left"
			return		

		datalist = []

		if (htype == MAXTURNSFORTIFIED):		
			for objUnit in unitList:
				turninformation = sdObjectGetVal("UnitStats", objUnit, TURNINFORMATION)
				datalist.append(turninformation[2])

		elif (htype == TOTALTURNSFORTIFIED):
			for objUnit in unitList:
				turninformation = sdObjectGetVal("UnitStats", objUnit, TURNINFORMATION)
				datalist.append(turninformation[0])	

		elif (htype == AVERAGEODDSLOWEST or htype == AVERAGEODDSHIGHEST):
			for objUnit in unitList:
				datalist.append(sdObjectGetVal("UnitStats", objUnit, AVERAGEODDS))
			
		elif (htype == BODYCOUNT or htype == BATTLECOUNT):	
			for objUnit in unitList:
				combatcount = sdObjectGetVal("UnitStats", objUnit, COMBATCOUNT)
				if (htype == BODYCOUNT):
					data = combatcount[ATTACK][1] + combatcount[DEFENCE][1]
				else:
					data = combatcount[ATTACK][0] + combatcount[DEFENCE][0]
				datalist.append(data)
	
		else:
			
			for i in range(10):
				if (htype == DAMAGETYPE[i]):
					for objUnit in unitList:
						damagestats = sdObjectGetVal("UnitStats", objUnit, DAMAGESTATS)
						data = damagestats[i]
						datalist.append(data)
					break
			
			else:
			
				for objUnit in unitList:
					datalist.append(sdObjectGetVal("UnitStats", objUnit, htype))

		
		#in order to check the oldest unit, the luckiest unit or the unit with the luckiest fight, we want the lowest score			
		if (htype == STARTTURN or htype == BESTODDS or htype == AVERAGEODDSLOWEST or htype == LIFEODDS):
			while min(datalist) == -1:
				datalist[datalist.index(-1)] = 6000
			highest = datalist.index(min(datalist))		
			objUnit = unitList[highest]
			# Get an ID string that is unique (unit.getID() isn't unique)
			UnitID = str(objUnit.getID())+ "X" + str(objUnit.getOwner())

			if ((htype == STARTTURN and min(datalist) < 6000) or min(datalist) < 101):
				if (g_bGlobalHighScore or not g_bTrackAllPlayers):
					sdSetVal("UnitStats", "Highscores", htype, min(datalist))
					sdSetVal("UnitStats", "HighscoreUnits", htype, UnitID)				
					if (min(datalist) < sdGetVal("UnitStats", "HighscoresHoF", htype)):
						sdSetVal("UnitStats", "HighscoresHoF", htype, min(datalist))
				else:
					self.sdObjectSetDictVal("UnitStats", objPlayer, "Highscores", htype, min(datalist))
					self.sdObjectSetDictVal("UnitStats", objPlayer, "HighscoreUnits", htype, UnitID)				
					if (min(datalist) < self.sdObjectGetDictVal("UnitStats", objPlayer, "HighscoresHoF", htype)):
						self.sdObjectSetDictVal("UnitStats", objPlayer, "HighscoresHoF", htype, min(datalist))

			else:
				if (g_bGlobalHighScore or not g_bTrackAllPlayers):
					sdSetVal("UnitStats", "Highscores", htype, min(datalist))
					sdSetVal("UnitStats", "HighscoreUnits", htype, -1)	
				else:
					self.sdObjectSetDictVal("UnitStats", objPlayer, "Highscores", htype, min(datalist))
					self.sdObjectSetDictVal("UnitStats", objPlayer, "HighscoreUnits", htype, -1)	


		else:
			highest = datalist.index(max(datalist))
			objUnit = unitList[highest]
			# Get an ID string that is unique (unit.getID() isn't unique)
			UnitID = str(objUnit.getID())+ "X" + str(objUnit.getOwner())
			if (max(datalist) > 0):
				if (g_bGlobalHighScore or not g_bTrackAllPlayers):
					sdSetVal("UnitStats", "Highscores", htype, max(datalist))
					sdSetVal("UnitStats", "HighscoreUnits", htype, UnitID)
					if (max(datalist) > sdGetVal("UnitStats", "HighscoresHoF", htype)):
						sdSetVal("UnitStats", "HighscoresHoF", htype, max(datalist))
				else:
					self.sdObjectSetDictVal("UnitStats", objPlayer, "Highscores", htype, max(datalist))
					self.sdObjectSetDictVal("UnitStats", objPlayer, "HighscoreUnits", htype, UnitID)
					if (max(datalist) > self.sdObjectGetDictVal("UnitStats", objPlayer, "HighscoresHoF", htype)):
						self.sdObjectSetDictVal("UnitStats", objPlayer, "HighscoresHoF", htype, max(datalist))

			
	#check if a current unit has the high score
	def	checkHighScoresCurrentUnit(self, highscorelist, objUnit):

		if (not g_bTrackHighScore):
			return

		objPlayer = gc.getPlayer(objUnit.getOwner())

		# Get an ID string that is unique (unit.getID() isn't unique)
		UnitID = str(objUnit.getID())+ "X" + str(objUnit.getOwner())

		#Initialize the Highscore-Entities if necessary

		if (g_bGlobalHighScore or not g_bTrackAllPlayers):
	
			#this entity stores the high score values
			if (sdEntityExists("UnitStats", "Highscores") == false):
				sdEntityInit("UnitStats", "Highscores", HighScoreTypes)

			#this entity stores the high score unit IDs
			if (sdEntityExists("UnitStats", "HighscoreUnits") == false):
				sdEntityInit("UnitStats", "HighscoreUnits", HighScoreTypes)
			
			#this entity stores the hall of fame high scores (high scores including dead units)	
			if (sdEntityExists("UnitStats", "HighscoresHoF") == false):
				sdEntityInit("UnitStats", "HighscoresHoF", HighScoreTypes)
				
		else:		
			#this entity stores the high score values
			if (sdObjectExists("UnitStats", objPlayer) == false):
				sdObjectInit("UnitStats", objPlayer, PlayerStatsData)


		#for every high score that is checked
		for htype in highscorelist:	

			
			#get the value of the unit that shall be tested
			if (htype == AVERAGEODDSLOWEST or htype == AVERAGEODDSHIGHEST):				
				iScore = sdObjectGetVal("UnitStats", objUnit, AVERAGEODDS)
			elif (htype == BODYCOUNT):
				combatcount = sdObjectGetVal("UnitStats", objUnit, COMBATCOUNT)
				iScore = combatcount[ATTACK][1] + combatcount[DEFENCE][1]
			elif (htype == BATTLECOUNT):
				combatcount = sdObjectGetVal("UnitStats", objUnit, COMBATCOUNT)
				iScore = combatcount[ATTACK][0] + combatcount[DEFENCE][0]

			else:
				for i in range(10):
					if (htype == DAMAGETYPE[i]):
						damagestats = sdObjectGetVal("UnitStats", objUnit, DAMAGESTATS)
						iScore = damagestats[i]
						break
				else:
					iScore = sdObjectGetVal("UnitStats", objUnit, htype)
			
			#get the current high score
			if (g_bGlobalHighScore or not g_bTrackAllPlayers):
				iHighScore = sdGetVal("UnitStats", "Highscores", htype)
			else:
				iHighScore = self.sdObjectGetDictVal("UnitStats", objPlayer, "Highscores", htype)

					
			#in order to check the oldest unit or the unit with the luckiest fight, we want the lowest score			
			if (htype == STARTTURN or htype == BESTODDS or htype == AVERAGEODDSLOWEST or htype == LIFEODDS):
			#if the current unit's score is lower than the high score, mark the unit as the best
				if ((iScore < iHighScore or iHighScore == -1) and (g_bGlobalHighScore or not g_bTrackAllPlayers)):
					sdSetVal("UnitStats", "Highscores", htype, iScore)
					sdSetVal("UnitStats", "HighscoreUnits", htype, UnitID)
					if (iScore < sdGetVal("UnitStats", "HighscoresHoF", htype)):
						sdSetVal("UnitStats", "HighscoresHoF", htype, iScore)

				elif(iScore < iHighScore or iHighScore == -1):
					self.sdObjectSetDictVal("UnitStats", objPlayer, "Highscores", htype, iScore)
					self.sdObjectSetDictVal("UnitStats", objPlayer, "HighscoreUnits", htype, UnitID)				
					if (iScore < self.sdObjectGetDictVal("UnitStats", objPlayer, "HighscoresHoF", htype)):
						self.sdObjectSetDictVal("UnitStats", objPlayer, "HighscoresHoF", htype, iScore)

			#if the current unit's score is higher than the high score, mark the unit as the best
			else:
				if (iScore > iHighScore and (g_bGlobalHighScore or not g_bTrackAllPlayers)):
					sdSetVal("UnitStats", "Highscores", htype, iScore)
					sdSetVal("UnitStats", "HighscoreUnits", htype, UnitID)
					if (iScore > sdGetVal("UnitStats", "HighscoresHoF", htype)):
						sdSetVal("UnitStats", "HighscoresHoF", htype, iScore)
				elif (iScore > iHighScore):
					self.sdObjectSetDictVal("UnitStats", objPlayer, "Highscores", htype, iScore)
					self.sdObjectSetDictVal("UnitStats", objPlayer, "HighscoreUnits", htype, UnitID)
					if (iScore > self.sdObjectGetDictVal("UnitStats", objPlayer, "HighscoresHoF", htype)):
						self.sdObjectSetDictVal("UnitStats", objPlayer, "HighscoresHoF", htype, iScore)


	# Get a list with all units that hold at least one high score. Needed for the unitstats screen.
	def getHighScoreUnits(self):
		highscorelist = self.getAllHighScores()
		HSUnitList = []
		HSIDList = []
		for htype in highscorelist:
			if (g_bGlobalHighScore or not g_bTrackAllPlayers):
				strUnit = sdGetVal("UnitStats", "HighscoreUnits", htype)
			else:
				strUnit = self.sdObjectGetDictVal("UnitStats", gc.getActivePlayer(), "HighscoreUnits", htype)
			if (not isinstance(strUnit, (int))):
				strUnitID, strPlayerID = strUnit.split("X")
				iPlayerID = int(strPlayerID)
				iUnitID = int(strUnitID)
				objUnit = gc.getPlayer(iPlayerID).getUnit(iUnitID)
				if (objUnit != None and HSIDList.count(strUnit) == 0 and objUnit.getID() != -1 and objUnit.getOwner() != -1):
					HSIDList.append(strUnit)
					HSUnitList.append(objUnit)			
		return HSUnitList

	# Get a list with all high scores a specific unit holds. Needed for the unitstats screen.
	def getHighScoresCurrentUnit(self, objUnit):
		highscorelist = self.getAllHighScores()
		HSList = []
		iUnitID = objUnit.getID()
		iPlayerID = objUnit.getOwner()
		for htype in highscorelist:
			if (g_bGlobalHighScore or not g_bTrackAllPlayers):
				strUnit = sdGetVal("UnitStats", "HighscoreUnits", htype)
			else:
				strUnit = self.sdObjectGetDictVal("UnitStats", gc.getActivePlayer(), "HighscoreUnits", htype)
			if (not isinstance(strUnit, (int))):
				strUnitID, strPlayerID = strUnit.split("X")
				if (iPlayerID == int(strPlayerID) and iUnitID == int(strUnitID)):
					HSList.append(htype)
		return HSList

	# Get a the unit that holds a certain high score. Needed for the unitstats screen.	
	def getHSUnit(self, htype):
		if (g_bGlobalHighScore or not g_bTrackAllPlayers):
			strUnit = sdGetVal("UnitStats", "HighscoreUnits", htype)
		else:
			strUnit = self.sdObjectGetDictVal("UnitStats", gc.getActivePlayer(), "HighscoreUnits", htype)
		if (not isinstance(strUnit, (int))):
			strUnitID, strPlayerID = strUnit.split("X")
			iPlayerID = int(strPlayerID)
			iUnitID = int(strUnitID)
			objUnit = gc.getPlayer(iPlayerID).getUnit(iUnitID)
			return objUnit
		return 0

	# Get a list with all high scores. Needed for the unitstats screen.	
	def getAllHighScores(self):
		messagestringlist = []

		if (g_bShowCombatCount):
			messagestringlist.extend([
								BODYCOUNT,
								BATTLECOUNT])

		if(g_bShowDamageInformation):				
			messagestringlist.extend([
								DAMAGETYPE[0],
					   			DAMAGETYPE[1],
					   			DAMAGETYPE[2],
					    		DAMAGETYPE[3],
					    		DAMAGETYPE[4],
					    		DAMAGETYPE[5],
					    		DAMAGETYPE[6],
					    		DAMAGETYPE[7],
					    		DAMAGETYPE[8],
					    		DAMAGETYPE[9]])

		if (g_bTrackMovement):
			messagestringlist.extend([
							  	MOVEMENT_COUNTER,
								WARP,
								CARGO_COUNTER])

		if (g_bShowExperience):	
			messagestringlist.append(
								EXPERIENCE)
										  
		messagestringlist.append(
							STARTTURN)

		if (g_bShowOdds):
			messagestringlist.extend([
							  	BESTODDS,
								AVERAGEODDSHIGHEST,
								AVERAGEODDSLOWEST,
								LIFEODDS,
								TOTALTURNSFORTIFIED,
								MAXTURNSFORTIFIED
										  ])
		return messagestringlist

	# Get a string with the best unit for this high score. Needed for the unitstats screen.	
	def getHSString(self, htype, strPlayerUnit):

		objPlayer = gc.getActivePlayer()

		if (g_bGlobalHighScore or not g_bTrackAllPlayers):
			pass
		
		if (strPlayerUnit == "player"):
			
			if (htype == BESTODDS):
				if (g_bGlobalHighScore or not g_bTrackAllPlayers):
					bestoddshs = sdGetVal("UnitStats", "Highscores", BESTODDS)
					bestoddshshof = sdGetVal("UnitStats", "HighscoresHoF", BESTODDS)
				else:
					bestoddshs = self.sdObjectGetDictVal("UnitStats", objPlayer, "Highscores", BESTODDS)
					bestoddshshof = self.sdObjectGetDictVal("UnitStats", objPlayer, "HighscoresHoF", BESTODDS)
				if (bestoddshshof == 101):			
					strHS = localText.getText("TXT_KEY_PLAYERHIGHSCORE_" + htype, ()) + "\n- (" + localText.getText("TXT_KEY_LIVING_UNITS", ()) +" -)"
				elif (bestoddshs == 101):
					temp = localText.getText("TXT_KEY_PLAYERHIGHSCORE_" + htype, ()) + "\n%.1f%% (" + localText.getText("TXT_KEY_LIVING_UNITS", ()) +" -)" 
					strHS = temp %(bestoddshshof)
				else:
					temp = localText.getText("TXT_KEY_PLAYERHIGHSCORE_" + htype, ()) + "\n%.1f%% (" + localText.getText("TXT_KEY_LIVING_UNITS", ()) +" %.1f%%)" 
					strHS = temp %(bestoddshshof, bestoddshs)
				return strHS	

			elif (htype == AVERAGEODDSHIGHEST):
				if (g_bGlobalHighScore or not g_bTrackAllPlayers):
					averageoddshighesths = sdGetVal("UnitStats", "Highscores", AVERAGEODDSHIGHEST)
					averageoddshighesthshof = sdGetVal("UnitStats", "HighscoresHoF", AVERAGEODDSHIGHEST)
				else:
					averageoddshighesths = self.sdObjectGetDictVal("UnitStats", objPlayer, "Highscores", AVERAGEODDSHIGHEST)
					averageoddshighesthshof = self.sdObjectGetDictVal("UnitStats", objPlayer, "HighscoresHoF", AVERAGEODDSHIGHEST)
				if (averageoddshighesthshof == -1):			
					strHS = localText.getText("TXT_KEY_PLAYERHIGHSCORE_" + htype, ()) + "\n- (" + localText.getText("TXT_KEY_LIVING_UNITS", ()) +" -)"
				elif (averageoddshighesths == -1):
					temp = localText.getText("TXT_KEY_PLAYERHIGHSCORE_" + htype, ()) + "\n%.1f%% (" + localText.getText("TXT_KEY_LIVING_UNITS", ()) +" -)"
					strHS = temp %(averageoddshighesthshof)
				else:
					temp = localText.getText("TXT_KEY_PLAYERHIGHSCORE_" + htype, ()) + "\n%.1f%% (" + localText.getText("TXT_KEY_LIVING_UNITS", ()) +" %.1f%%)" 
					strHS = temp %(averageoddshighesthshof, averageoddshighesths)
				return strHS	

			elif (htype == AVERAGEODDSLOWEST):	
				if (g_bGlobalHighScore or not g_bTrackAllPlayers):
					averageoddslowesths = sdGetVal("UnitStats", "Highscores", AVERAGEODDSLOWEST)
					averageoddslowesthshof = sdGetVal("UnitStats", "HighscoresHoF", AVERAGEODDSLOWEST)
				else:
					averageoddslowesths = self.sdObjectGetDictVal("UnitStats", objPlayer, "Highscores", AVERAGEODDSLOWEST)
					averageoddslowesthshof = self.sdObjectGetDictVal("UnitStats", objPlayer, "HighscoresHoF", AVERAGEODDSLOWEST)
				if (averageoddslowesthshof >= 101):			
					strHS = localText.getText("TXT_KEY_PLAYERHIGHSCORE_" + htype, ()) + "\n- (" + localText.getText("TXT_KEY_LIVING_UNITS", ()) +" -)"
				elif (averageoddslowesths >= 101):
					temp = localText.getText("TXT_KEY_PLAYERHIGHSCORE_" + htype, ()) + "\n%.1f%% (" + localText.getText("TXT_KEY_LIVING_UNITS", ()) +" -)" 
					strHS = temp %(averageoddslowesthshof)
				else:
					temp = localText.getText("TXT_KEY_PLAYERHIGHSCORE_" + htype, ()) + "\n%.1f%% (" + localText.getText("TXT_KEY_LIVING_UNITS", ()) +" %.1f%%)" 
					strHS = temp %(averageoddslowesthshof, averageoddslowesths)
				return strHS
			
			elif (htype == LIFEODDS):
				if (g_bGlobalHighScore or not g_bTrackAllPlayers):
					lifeoddshs = sdGetVal("UnitStats", "Highscores", LIFEODDS)
					lifeoddshshof = sdGetVal("UnitStats", "HighscoresHoF", LIFEODDS)
				else:
					lifeoddshs = self.sdObjectGetDictVal("UnitStats", objPlayer, "Highscores", LIFEODDS)
					lifeoddshshof = self.sdObjectGetDictVal("UnitStats", objPlayer, "HighscoresHoF", LIFEODDS)
				if (lifeoddshshof >= 101):			
					strHS = localText.getText("TXT_KEY_PLAYERHIGHSCORE_" + htype, ()) + "\n- (" + localText.getText("TXT_KEY_LIVING_UNITS", ()) +" -)"
				elif (lifeoddshs >= 101):
					temp = localText.getText("TXT_KEY_PLAYERHIGHSCORE_" + htype, ()) + "\n%.1f%% (" + localText.getText("TXT_KEY_LIVING_UNITS", ()) +" -)" 
					strHS = temp %(lifeoddshshof)
				else:
					temp = localText.getText("TXT_KEY_PLAYERHIGHSCORE_" + htype, ()) + "\n%.1f%% (" + localText.getText("TXT_KEY_LIVING_UNITS", ()) +" %.1f%%)" 
					strHS = temp %(lifeoddshshof, lifeoddshs)
				return strHS

			elif (htype == STARTTURN):
				if (g_bGlobalHighScore or not g_bTrackAllPlayers):
					startturnhighesths = sdGetVal("UnitStats", "Highscores", STARTTURN)
					startturnhighesthshof = sdGetVal("UnitStats", "HighscoresHoF", STARTTURN)
				else:
					startturnhighesths = self.sdObjectGetDictVal("UnitStats", objPlayer, "Highscores", STARTTURN)
					startturnhighesthshof = self.sdObjectGetDictVal("UnitStats", objPlayer, "HighscoresHoF", STARTTURN)
				if (startturnhighesthshof == -1 and startturnhighesths == -1):			
					strHS = localText.getText("TXT_KEY_PLAYERHIGHSCORE_" + htype, (0,0))
				elif (startturnhighesthshof == -1 and startturnhighesths != -1):			
					strHS = localText.getText("TXT_KEY_PLAYERHIGHSCORE_" + htype, (gc.getGame().getGameTurn() - startturnhighesths, gc.getGame().getGameTurn() - startturnhighesths))
				elif (startturnhighesthshof != -1 and startturnhighesths == -1):
					strHS = localText.getText("TXT_KEY_PLAYERHIGHSCORE_" + htype, (gc.getGame().getGameTurn() - startturnhighesthshof, 0))
				else:
					strHS = localText.getText("TXT_KEY_PLAYERHIGHSCORE_" + htype, (gc.getGame().getGameTurn() - startturnhighesthshof, gc.getGame().getGameTurn() - startturnhighesths))
				return strHS	
			
			elif (htype == DAMAGETYPE[0] or htype == DAMAGETYPE[1] or htype == DAMAGETYPE[2] or htype == DAMAGETYPE[3] or htype == DAMAGETYPE[4] or htype == DAMAGETYPE[5] or htype == DAMAGETYPE[6] or htype == DAMAGETYPE[7] or htype == DAMAGETYPE[8] or htype == DAMAGETYPE[9]):	
				str2ndpartstring = "\n %.2f (" + localText.getText("TXT_KEY_LIVING_UNITS", ()) + " %.2f)"
			else:
				str2ndpartstring = "\n%s (" + localText.getText("TXT_KEY_LIVING_UNITS", ()) + " %s)"
		
			strHS = localText.getText("TXT_KEY_PLAYERHIGHSCORE_" + htype, ()) + str2ndpartstring

			# The high score and the hall of fame high score for this high score type are loaded
			if (g_bGlobalHighScore or not g_bTrackAllPlayers):
				hs = sdGetVal("UnitStats", "Highscores", htype)
				hshof = sdGetVal("UnitStats", "HighscoresHoF", htype)
			else:
				hs = self.sdObjectGetDictVal("UnitStats", objPlayer, "Highscores", htype)
				hshof = self.sdObjectGetDictVal("UnitStats", objPlayer, "HighscoresHoF", htype)

			# A message is added, using the string saved in the messagestringlist and actual high scores.
			strHS = strHS %(hshof, hs)
			return strHS

		if (strPlayerUnit == "unit"):

			strHS = localText.getText("TXT_KEY_UNITHIGHSCORE_" + htype, ())

			return strHS


	# Launches the popup (strStatType is either "unit" or "player")
	def launchPopup(self, objUnit, strStatType):
		
		# Create the popup
		popup = PyPopup.PyPopup()
		# TODO - CHANGE THIS CODE TO CENTER POPUP
		if (strStatType == "unit"):		
			popup.setHeaderString("Unit Statistics: %s" %(objUnit.getNameNoDesc()))
			popup.setBodyString(self.getUnitStatisticsString(objUnit))
		elif (strStatType == "player"):		
			popup.setHeaderString("Player statistics")
			popup.setBodyString(self.getPlayerStatisticsString())
		popup.setPosition(100,100)
		popup.setSize(700,500)
		popup.launch()

	def getUnitStatisticsString(self, objUnit):	

		# Return immediately if we got an invalid unit
		if(objUnit == None):
			return
		
		# Return immediately if the unit passed in doesn't belong to the 
		# currently active player
		if(objUnit.getOwner() != gc.getGame().getActivePlayer() and not g_bTrackAllPlayers):
			return
	
		# Get an ID string that is unique (unit.getID() isn't unique)
		UnitID = str(objUnit.getID())+ "X" + str(objUnit.getOwner())	

		message1 = sdObjectGetVal("UnitStats", objUnit, LIST)	
		
		turninformation = sdObjectGetVal("UnitStats", objUnit, TURNINFORMATION)
		totalturnsfortified = turninformation[0]
		maxturnsfortified = turninformation[2]
		
		capturecount = sdObjectGetVal("UnitStats", objUnit, CAPTURECOUNT)
		
		combatcount = sdObjectGetVal("UnitStats", objUnit, COMBATCOUNT)
		numberOfKills = combatcount[ATTACK][1] + combatcount[DEFENCE][1]
		numberOfKillsAttacking = combatcount[ATTACK][1]
		numberOfKillsDefending = combatcount[DEFENCE][1]
		battlecount = combatcount[ATTACK][0] + combatcount[DEFENCE][0]
		battlecountAttacking = combatcount[ATTACK][0]
		battlecountDefending = combatcount[DEFENCE][0]
		withdrawalcount = combatcount[ATTACK][3] + combatcount[DEFENCE][3]
		withdrawalcountAttacking = combatcount[ATTACK][3]
		withdrawalcountDefending = combatcount[DEFENCE][3]
		
		airnumberOfKills = combatcount[AIRATTACK][1] + combatcount[AIRDEFENCE][1]
		airnumberOfKillsAttacking = combatcount[AIRATTACK][1]
		airnumberOfKillsDefending = combatcount[AIRDEFENCE][1]
		airbattlecount = combatcount[AIRATTACK][0] + combatcount[AIRDEFENCE][0]
		airbattlecountAttacking = combatcount[AIRATTACK][0]
		airbattlecountDefending = combatcount[AIRDEFENCE][0]
		airstrikecount = combatcount[AIRSTRIKE][0]
		airstrikecountdefending = combatcount[AIRSTRIKE][1]
		
		startturn = sdObjectGetVal("UnitStats", objUnit, STARTTURN)
		servicelengthturns = (gc.getGame().getGameTurn() - startturn)
		startyear = sdObjectGetVal("UnitStats", objUnit, STARTDATE)
		servicelengthyears = gc.getGame().getGameTurnYear() - startyear
		
		cargocounter = sdObjectGetVal("UnitStats", objUnit, CARGO_COUNTER)
		movecounter = sdObjectGetVal("UnitStats", objUnit, MOVEMENT_COUNTER)
		distancewarped = sdObjectGetVal("UnitStats", objUnit, WARP)
		distancetransported = sdObjectGetVal("UnitStats", objUnit, WARP) - sdObjectGetVal("UnitStats", objUnit, MOVEMENT_COUNTER)
		#sdObjectSetVal("UnitStats", objUnit, TRANSPORT, distancetransported)

		damagestats = sdObjectGetVal("UnitStats", objUnit, DAMAGESTATS)
		damageinflicted = str("%.2f") %(damagestats[0])
		damageinflictedattacking = str("%.2f") %(damagestats[1])
		damageinflicteddefending = str("%.2f") %(damagestats[2])
		damagesuffered = str("%.2f") %(damagestats[3])
		damagesufferedattacking = str("%.2f") %(damagestats[4])
		damagesuffereddefending = str("%.2f") %(damagestats[5])
		collateraldamageinflicted = str("%.2f") %(damagestats[6])
		collateraldamagesuffered = str("%.2f") %(damagestats[7])
		airstrikedamageinflicted = str("%.2f") %(damagestats[8])
		airstrikedamagesuffered = str("%.2f") %(damagestats[9])
		
		averageodds = str("%.1f%%") %(sdObjectGetVal("UnitStats", objUnit, AVERAGEODDS))
		bestodds = sdObjectGetVal("UnitStats", objUnit, BESTODDS)
		if (not isinstance(bestodds, (str))):
			bestodds = str("%.1f%%") %(sdObjectGetVal("UnitStats", objUnit, BESTODDS))
		oddsdata = sdObjectGetVal("UnitStats", objUnit, ODDSDATA)
		lifeodds = str("%.1f%%") %(sdObjectGetVal("UnitStats", objUnit, LIFEODDS))	
		
		strCombatCount = ""
		if(g_bShowCombatCount):
			strCombatCount = localText.getText("TXT_KEY_BATTLES_FOUGHT", (battlecount, battlecountAttacking, battlecountDefending)) + "\n"
			#strCombatCount = strCombatCount %(battlecount, battlecountAttacking, battlecountDefending)
			strCombatCount = strCombatCount + localText.getText("TXT_KEY_UNITS_KILLED", (numberOfKills, numberOfKillsAttacking, numberOfKillsDefending)) + "\n"
			strCombatCount = strCombatCount + localText.getText("TXT_KEY_UNDECIDED_BATTLES", (withdrawalcount, withdrawalcountAttacking, withdrawalcountDefending)) + "\n\n"
#			strCombatCount = strCombatCount + "Cities captured: %s\n\n" %(capturecount)
			
		if (objUnit.getDomainType() == 1):
			strCombatCount = localText.getText("TXT_KEY_NUM_AIR_STRIKES", (airstrikecount)) + "\n"
			strCombatCount = strCombatCount + localText.getText("TXT_KEY_NUM_AIR_COMBATS", (airbattlecount, airbattlecountAttacking, airbattlecountDefending)) + "\n"
			strCombatCount = strCombatCount + localText.getText("TXT_KEY_NUM_AIR_KILLS", (airnumberOfKills, airnumberOfKillsAttacking, airnumberOfKillsDefending)) + "\n\n"

		strDistanceInformation = ""
		
		if(g_bTrackMovement):
			strDistanceInformation = localText.getText("TXT_KEY_MOVECOUNTERS", (movecounter, distancetransported, distancewarped))
			if (cargocounter > 0):
				strDistanceInformation = strDistanceInformation + "\n" + localText.getText("TXT_KEY_CARGOCOUNTER", (cargocounter, ()))

		# If some distance information is being displayed then add the blank 
		# line spacers.
			if(len(strDistanceInformation) > 0):
				strDistanceInformation = strDistanceInformation + " \n \n"
					
		if(not g_bShowUnitEventLog):
			message1 = ""

		strDamageInformation = ""
		if(g_bShowDamageInformation):	
			strDamageInformation = strDamageInformation + localText.getText("TXT_KEY_DAMAGE_INFLICTED", (damageinflicted, damageinflictedattacking, damageinflicteddefending, collateraldamageinflicted, airstrikedamageinflicted)) + "\n"	
			strDamageInformation = strDamageInformation + localText.getText("TXT_KEY_DAMAGE_SUFFERED", (damagesuffered, damagesufferedattacking, damagesuffereddefending, collateraldamagesuffered, airstrikedamagesuffered)) + "\n\n"
		
		strOddsInformation = "\n\n\n"
		
		if (g_bShowOdds and averageodds != "-1.0%"):
			strOddsInformation = localText.getText("TXT_KEY_ODDSINFORMATION", (averageodds, lifeodds, oddsdata[2])) + "\n"

		strTurnInformation = ""
		if (g_bTrackTurnInformation):
			strTurnInformation = localText.getText("TXT_KEY_TOTALTIMEFORTIFIED", (totalturnsfortified,())) + "\n"
			strTurnInformation = strTurnInformation + localText.getText("TXT_KEY_MAXTIMEFORTIFIED", (maxturnsfortified, ())) + "\n\n"

			
		return "%s%s%s%s%s%s" %(strCombatCount, strOddsInformation, strDamageInformation, strDistanceInformation, strTurnInformation, message1)

	# Launches the player statistics popup 
	def getPlayerStatisticsString(self):
	
		# Get the currently active player
		PlayerID = "PlayerStats" + str(gc.getActivePlayer().getID())

		combatcount = sdObjectGetVal("UnitStats", gc.getActivePlayer(), COMBATCOUNT)
		numberOfKills = combatcount[ATTACK][1] + combatcount[DEFENCE][1]
		numberOfKillsAttacking = combatcount[ATTACK][1]
		numberOfKillsDefending = combatcount[DEFENCE][1]
		battlecount = combatcount[ATTACK][0] + combatcount[DEFENCE][0]
		battlecountAttacking = combatcount[ATTACK][0]
		battlecountDefending = combatcount[DEFENCE][0]
		losscount = combatcount[ATTACK][2] + combatcount[DEFENCE][2]
		losscountAttacking = combatcount[ATTACK][2]
		losscountDefending = combatcount[DEFENCE][2]
		withdrawalcount = combatcount[ATTACK][3] + combatcount[DEFENCE][3]
		withdrawalcountAttacking = combatcount[ATTACK][3]
		withdrawalcountDefending = combatcount[DEFENCE][3]

		airnumberOfKills = combatcount[AIRATTACK][1] + combatcount[AIRDEFENCE][1]
		airnumberOfKillsAttacking = combatcount[AIRATTACK][1]
		airnumberOfKillsDefending = combatcount[AIRDEFENCE][1]
		airbattlecount = combatcount[AIRATTACK][0] + combatcount[AIRDEFENCE][0]
		airbattlecountAttacking = combatcount[AIRATTACK][0]
		airbattlecountDefending = combatcount[AIRDEFENCE][0]
		airstrikecount = combatcount[AIRSTRIKE][0]
		airstrikecountdefending = combatcount[AIRSTRIKE][1]
		airlosscount = combatcount[AIRATTACK][2] + combatcount[AIRDEFENCE][2]
		airlosscountAttacking = combatcount[AIRATTACK][2]
		airlosscountDefending = combatcount[AIRDEFENCE][2]

		
		turninformation = sdObjectGetVal("UnitStats", gc.getActivePlayer(), TURNINFORMATION)
		totalturnsfortified = turninformation[0]
		maxturnsfortified = turninformation[2]
		
		cargocounter = sdObjectGetVal("UnitStats", gc.getActivePlayer(), CARGO_COUNTER)
		movecounter = sdObjectGetVal("UnitStats", gc.getActivePlayer(), MOVEMENT_COUNTER)
		distancewarped = sdObjectGetVal("UnitStats", gc.getActivePlayer(), WARP)
		distancetransported = sdObjectGetVal("UnitStats", gc.getActivePlayer(), WARP) - sdObjectGetVal("UnitStats", gc.getActivePlayer(), MOVEMENT_COUNTER)
		#sdObjectSetVal("UnitStats", gc.getActivePlayer(), TRANSPORT, distancetransported)

		damagestats = sdObjectGetVal("UnitStats", gc.getActivePlayer(), DAMAGESTATS)
		damageinflicted = str("%.2f") %(damagestats[0])
		damageinflictedattacking = str("%.2f") %(damagestats[1])
		damageinflicteddefending = str("%.2f") %(damagestats[2])
		damagesuffered = str("%.2f") %(damagestats[3])
		damagesufferedattacking = str("%.2f") %(damagestats[4])
		damagesuffereddefending = str("%.2f") %(damagestats[5])
		collateraldamageinflicted = str("%.2f") %(damagestats[6])
		collateraldamagesuffered = str("%.2f") %(damagestats[7])
		airstrikedamageinflicted = str("%.2f") %(damagestats[8])
		airstrikedamagesuffered = str("%.2f") %(damagestats[9])

		goodies = sdObjectGetVal("UnitStats", gc.getActivePlayer(), GOODIES)
		experience = sdObjectGetVal("UnitStats", gc.getActivePlayer(), EXPERIENCE)
				
		strCombatCount = ""
		if(g_bShowCombatCount):
			strCombatCount = localText.getText("TXT_KEY_BATTLES_FOUGHT", (battlecount, battlecountAttacking, battlecountDefending)) + "\n"
			strCombatCount = strCombatCount + localText.getText("TXT_KEY_UNITS_KILLED", (numberOfKills, numberOfKillsAttacking, numberOfKillsDefending)) + "\n"
			strCombatCount = strCombatCount + localText.getText("TXT_KEY_UNITS_LOST", (losscount, losscountAttacking, losscountDefending)) + "\n"
			strCombatCount = strCombatCount + localText.getText("TXT_KEY_UNDECIDED_BATTLES", (withdrawalcount, withdrawalcountAttacking, withdrawalcountDefending)) + "\n\n"

		strAirCombatCount = ""
		if(g_bShowCombatCount):
			strAirCombatCount = localText.getText("TXT_KEY_NUM_AIR_STRIKES", (airstrikecount, ())) + "\n"
			strAirCombatCount = strAirCombatCount + localText.getText("TXT_KEY_NUM_AIR_COMBATS", (airbattlecount, airbattlecountAttacking, airbattlecountDefending)) + "\n"
			strAirCombatCount = strAirCombatCount + localText.getText("TXT_KEY_NUM_AIR_KILLS", (airnumberOfKills, airnumberOfKillsAttacking, airnumberOfKillsDefending)) + "\n\n"
		
		strDistanceInformation = ""	
		if(g_bTrackMovement):
			strDistanceInformation = localText.getText("TXT_KEY_MOVECOUNTERS", (movecounter, distancetransported, distancewarped))
			if (cargocounter > 0):
				strDistanceInformation = strDistanceInformation + "\n" + localText.getText("TXT_KEY_CARGOCOUNTER", (cargocounter, ()))
		# If some distance information is being displayed then add the blank 
		# line spacers.
			if(len(strDistanceInformation) > 0):
				strDistanceInformation = strDistanceInformation + " \n \n"
					
		if(not g_bShowUnitEventLog):
			message1 = ""

		strTurnInformation = ""	
		if (g_bTrackTurnInformation):		
			strTurnInformation = strTurnInformation + localText.getText("TXT_KEY_TOTALTIMEFORTIFIED", (totalturnsfortified, ())) + "\n"
			strTurnInformation = strTurnInformation + localText.getText("TXT_KEY_MAXTIMEFORTIFIED", (maxturnsfortified, ())) + "\n\n"

		strDamageInformation = ""
	
		if(g_bShowDamageInformation):		
			strDamageInformation = strDamageInformation + localText.getText("TXT_KEY_DAMAGE_INFLICTED", (damageinflicted, damageinflictedattacking, damageinflicteddefending, collateraldamageinflicted, airstrikedamageinflicted)) + "\n"	
			strDamageInformation = strDamageInformation + localText.getText("TXT_KEY_DAMAGE_SUFFERED", (damagesuffered, damagesufferedattacking, damagesuffereddefending, collateraldamagesuffered, airstrikedamagesuffered)) + "\n\n"
			
		strMiscInformation = ""
		
		if (g_bShowExperience):
			strMiscInformation = strMiscInformation + localText.getText("TXT_KEY_EXPERIENCE_GAINED", (experience, ())) + "\n"
		if (g_bTrackGoodyReceived):
			strMiscInformation = strMiscInformation + localText.getText("TXT_KEY_GOODIES_RECEIVED", (goodies,()))
			

		return "%s%s%s%s%s%s" %(strCombatCount, strDamageInformation, strAirCombatCount, strDistanceInformation, strTurnInformation, strMiscInformation)
			


	# Begins logging the unit information.
	def beginLoggingUnit(self, strCityName, objUnit, iPlayerID):
	
		# Get the currently active player
		objPlayer = gc.getPlayer(objUnit.getOwner())
		
		# Return immediately if the city name passed in is invalid, if this 
		# does happen then the unit information will still be logged through
		# the logUnitCreated method. 
		if(strCityName == None):
			return
			
		# Return immediately if the city name passed in is empty, if this 
		# does happen then the unit information will still be logged through
		# the logUnitCreated method. 
		if(strCityName == ""):
			return		
			
		# Return immediately if the unit passed in is invalid
		if(objUnit == None):
			return
			
		# Return immediately if the player ID passed in is invalid
		if(objPlayer == None):
			return

		# Get the game clock string
		strGameClock = self.getCurrentGameClockString(objUnit.getOwner())
		
		# Construct the unit built message
		newBuiltMessage = "%s: %s " + localText.getText("TXT_KEY_UNITSTATS_BUILTIN", ()) + " %s \n"
		newBuiltMessage = newBuiltMessage %(strGameClock, gc.getUnitInfo(objUnit.getUnitType()).getDescription(), strCityName)

		# This call is used instead of updateUnitLog since using 
		# updateUnitLog will cause a double entry when the unit is built.
		sdObjectSetVal("UnitStats", objUnit, LIST, newBuiltMessage)
		
		# Log Experience of the unit.
		sdObjectSetVal("UnitStats", objUnit, EXPERIENCE, objUnit.getExperience())
		
		# Log Experience for player stats.
		sdObjectSetVal("UnitStats", gc.getPlayer(objUnit.getOwner()), EXPERIENCE, sdObjectGetVal("UnitStats", gc.getPlayer(objUnit.getOwner()), EXPERIENCE) + objUnit.getExperience())
		
		#This checks the unit for high scores (experience)
		if (g_bTrackHighScore):
			self.checkHighScoresCurrentUnit([EXPERIENCE], objUnit)

		
	# Logs the creation of a unit by the player represented by the iPlayerID
	def logUnitCreation(self, objUnit, iPlayerID):

		# Get the currently active player
		objPlayer = gc.getPlayer(objUnit.getOwner())

		# Return immediately if the unit passed in is invalid
		if(objUnit == None):
			return
			
		# Return immediately if the player ID passed in is invalid
		if(objPlayer == None):
			return

		if (sdObjectExists("UnitStats", objUnit) == false):
			sdObjectInit("UnitStats", objUnit, UnitStatsData)

		if(sdObjectExists("UnitStats", gc.getPlayer(objUnit.getOwner())) == False):
			sdObjectInit("UnitStats", gc.getPlayer(objUnit.getOwner()), PlayerStatsData)


		# If the unit doesn't have a name already then try to give them one	
		if(len(objUnit.getNameNoDesc()) == 0):
		
			# Get the next possible unit name
			strUnitName = self.getNextUnitName(objUnit)

			# If the possible unit name is valid then set it as the unit's name
			if(strUnitName != None and len(strUnitName) > 0):
				objUnit.setName(strUnitName)

		# Save the new units location
		sdObjectSetVal("UnitStats", objUnit, PLOT, [objUnit.getX(), objUnit.getY()])
		
		# Save start turn, start year and starting experience
 		sdObjectSetVal("UnitStats", objUnit, STARTDATE, gc.getGame().getGameTurnYear())
 		sdObjectSetVal("UnitStats", objUnit, STARTTURN, gc.getGame().getGameTurn())
 		sdObjectSetVal("UnitStats", objUnit, EXPERIENCE, objUnit.getExperience())


		# Get the game clock string
		strGameClock = self.getCurrentGameClockString(objUnit.getOwner())

		# Construct the unit creation message
		newCreatedMessage = "%s: %s " + localText.getText("TXT_KEY_UNITSTATS_CREATED", ()) + "\n"
		newCreatedMessage = newCreatedMessage %(strGameClock, gc.getUnitInfo(objUnit.getUnitType()).getDescription())
		
		# log the creation message for the unit.
		self.updateUnitLog(objUnit, newCreatedMessage)

		#This checks the unit for high scores (oldest unit)
		if (g_bTrackHighScore):
			self.checkHighScoresCurrentUnit([STARTTURN], objUnit)

		return


	# Logs the movement of a unit
	def logUnitMove(self, objUnit):
		
		iPlayerID = objUnit.getOwner()
		
		# Return immediately if the unit passed in is invalid
		if(objUnit == None):
			return
		
		# Get the amount of moves the unit has made in the past and increment 
		# it by one. 
		iMovementCounter = sdObjectGetVal("UnitStats", objUnit, MOVEMENT_COUNTER) + 1
		
		# Set the new movement count
		sdObjectSetVal("UnitStats", objUnit, MOVEMENT_COUNTER, iMovementCounter)
		
		# Set the player statistics movement count.
		sdObjectSetVal("UnitStats", gc.getPlayer(objUnit.getOwner()), MOVEMENT_COUNTER, sdObjectGetVal("UnitStats", gc.getPlayer(objUnit.getOwner()), MOVEMENT_COUNTER) + 1)
		
		#Check movement high scores
		if (g_bTrackHighScore):
			self.checkHighScoresCurrentUnit([MOVEMENT_COUNTER], objUnit)


		# If the unit is a transport unit
		if (objUnit.hasCargo()):
			
			# Get the amount of moves the unit has made with cargo in the past and increment 
			# it by one. 		
			sdObjectSetVal("UnitStats", objUnit, CARGO_COUNTER, sdObjectGetVal("UnitStats", objUnit, CARGO_COUNTER) + 1)

			# Set the player statistics cargo movement count.
			sdObjectSetVal("UnitStats", gc.getPlayer(objUnit.getOwner()), CARGO_COUNTER, sdObjectGetVal("UnitStats", gc.getPlayer(objUnit.getOwner()), CARGO_COUNTER) + 1)
	
			#Check cargo high scores
			if (g_bTrackHighScore):
				self.checkHighScoresCurrentUnit([CARGO_COUNTER], objUnit)


	# Logs the setting of the location of the unit.
	# should this really be called every time a unit moves? Maybe we just need 
	# to fix all of the players units at the end of their upkeep cycle?
	def logUnitLocation(self, objUnit):
		
		# Return immediately if the unit passed in is invalid
		if(objUnit == None):
			return

		iDistanceWarped = 0

		if (sdObjectExists("UnitStats", objUnit) == false):
			sdObjectInit("UnitStats", objUnit, UnitStatsData)
			
		if(sdObjectExists("UnitStats", gc.getPlayer(objUnit.getOwner())) == False):
			sdObjectInit("UnitStats", gc.getPlayer(objUnit.getOwner()), PlayerStatsData)


		# Get the old unit location values
		OldPlot = sdObjectGetVal("UnitStats", objUnit, PLOT)
		
		iOldX = OldPlot[0]
		iOldY = OldPlot[1]

		# Get the new unit location values
		iNewX = objUnit.getX()
		iNewY = objUnit.getY()

		# Set the new unit location values	
		sdObjectSetVal("UnitStats", objUnit, PLOT, [iNewX, iNewY])

		# If the old location values and the new location values are valid
		# then calculate the distance between the two
		if(iOldX > 0 and iOldY > 0 and iNewX > 0 and iNewY > 0):
			iDistanceWarped = max(abs(iOldX-iNewX), abs(iOldY-iNewY))

			# Get the old distance warped and add the new distance warped
			newDistanceWarped = sdObjectGetVal("UnitStats", objUnit, WARP) + iDistanceWarped
			
			# Set the new distance warped amount
			sdObjectSetVal("UnitStats", objUnit, WARP, newDistanceWarped)
	
			# Set the player statistics distance warped amount.
			sdObjectSetVal("UnitStats", gc.getPlayer(objUnit.getOwner()), WARP, sdObjectGetVal("UnitStats", gc.getPlayer(objUnit.getOwner()), WARP) + iDistanceWarped)
		
			# Check distance travelled high scores
			if (g_bTrackHighScore):
				self.checkHighScoresCurrentUnit([WARP], objUnit)

	# Logs everything that is checked every turn (so far, the number of turns fortified)
	def logBeginPlayerTurn(self, argsList):
		iGameTurn, iPlayer = argsList
		pyPlayer = PyPlayer(iPlayer)
		unitList = pyPlayer.getUnitList()
		playerturninformation = sdObjectGetVal("UnitStats", gc.getPlayer(iPlayer), TURNINFORMATION)
		for unit in unitList:
			unitturninformation = sdObjectGetVal("UnitStats", unit, TURNINFORMATION)
			if (unit.fortifyModifier() > 0):
				unitturninformation[0] = unitturninformation[0] + 1
				playerturninformation[0] = playerturninformation[0] + 1
				unitturninformation[1] = unitturninformation[1] + 1
				if (unitturninformation[1] > unitturninformation[2]):
					unitturninformation[2] = unitturninformation[1]
					if (unitturninformation[2] > playerturninformation[2]):
						playerturninformation[2] = unitturninformation[2]	
			else:
				unitturninformation[1] = 0
			sdObjectSetVal("UnitStats", unit, TURNINFORMATION, unitturninformation)
		sdObjectSetVal("UnitStats", gc.getPlayer(iPlayer), TURNINFORMATION, playerturninformation)

		self.checkHighScoresAllUnits(MAXTURNSFORTIFIED, iPlayer)
		self.checkHighScoresAllUnits(TOTALTURNSFORTIFIED, iPlayer)
			
	# Logs the goody received event				
	def logUnitGoodyReceived(self, objUnit, iGoodyTypeID):
		# Get the goody information
		objGoodyInfo = gc.getGoodyInfo(iGoodyTypeID)

		# Return immediately if the unit passed in is invalid
		if(objUnit == None):
			return
			
		# Return immediately if the goody ID passed in is invalid
		if(objGoodyInfo == None):
			return

		# Return immediately if for some reason we haven't been logging the 
		# unit. TODO: Maybe this condition should be handled differently?
		if(sdObjectExists("UnitStats", objUnit) == False):
			return
			
		# Get the game clock string
		strGameClock = self.getCurrentGameClockString(objUnit.getOwner())

		# Construct the unit creation message
		strGoodyDescription = objGoodyInfo.getDescription()
		newGoodyMessage = "%s: %s \n" %(strGameClock, strGoodyDescription)

		# log the goody message for the unit.
		self.updateUnitLog(objUnit, newGoodyMessage)

		# log the goody for player statistics:
		sdObjectSetVal("UnitStats", gc.getPlayer(objUnit.getOwner()), GOODIES, sdObjectGetVal("UnitStats", gc.getPlayer(objUnit.getOwner()), GOODIES) + 1)

	# Logs the city acquired event				
	def logCityCapture(self, argsList):

		owner,playerType,city,bConquest,bTrade = argsList

		print "acquired test3"
		
		for i in range(city.plot().getNumUnits()):
			objUnit = city.plot().getUnit(i)
			if (objUnit.getOwner() == gc.getGame().getActivePlayer()):
				break
		else:
			return

		print "acquired test4"

		# Return immediately if for some reason we haven't been logging the 
		# unit. TODO: Maybe this condition should be handled differently?
		if(sdObjectExists("UnitStats", objUnit) == False):
			return
		
		# Get the game clock string
		strGameClock = self.getCurrentGameClockString(objUnit.getOwner())

		# Construct the city capture message
		strCaptureDescription = "Captured %s from the %s" %(city.getName(), owner.getCivilizationDescriptionKey())
		newCaptureMessage = "%s: %s \n" %(strGameClock, strCaptureDescription)

		# log the capture message for the unit.
		self.updateUnitLog(objUnit, newCaptureMessage)

		# log the capture for player statistics:
		sdObjectSetVal("UnitStats", gc.getPlayer(objUnit.getOwner()), CAPTURECOUNT, sdObjectGetVal("UnitStats", gc.getPlayer(objUnit.getOwner()), CAPTURECOUNT) + 1)


	# Logs the goody received event				
	def logUnitUpgraded(self, argsList):

		genericArgs = argsList[0][0]
		pOldUnit = genericArgs[0]
		pNewUnit = genericArgs[1]

		# Return immediately if the unit passed in is invalid
		if(pOldUnit == None):
			return
		
		# Return immediately if the unit passed in is invalid
		if(pNewUnit == None):
			return

		# Return immediately if for some reason we haven't been logging the 
		# unit. TODO: Maybe this condition should be handled differently?
		if(sdObjectExists("UnitStats", pNewUnit) == False):
			return
			
		# Get the game clock string
		strGameClock = self.getCurrentGameClockString(pNewUnit.getOwner())

		# Construct the unit upgrade message
		newUpgradeMessage = "%s: " + localText.getText("TXT_KEY_UNITSTATS_UPGRADE", ()) +" \n"
		newUpgradeMessage = newUpgradeMessage %(strGameClock, PyInfo.UnitInfo(pOldUnit.getUnitType()).getDescription(), PyInfo.UnitInfo(pNewUnit.getUnitType()).getDescription())

		# log the goody message for the unit.
		self.updateUnitLog(pNewUnit, newUpgradeMessage)



	# Logs the combat results event	
	def logCombatResults(self, objWinner, objLoser):
	
		# Return immediately if the objWinner passed in is invalid
		if(objWinner == None):
			return

		objUnit = objWinner

		UnitID = str(objUnit.getID())+ "X" + str(objUnit.getOwner())
		
		objLosingPlayer = PyPlayer(objLoser.getOwner())
		
		# Return immediately if for some reason we haven't been logging the 
		# unit. TODO: Maybe this condition should be handled differently?
		if(sdObjectExists("UnitStats", objUnit) == False):
			return
	
		# log the experience of the unit
		sdObjectSetVal("UnitStats", objUnit, EXPERIENCE, objWinner.getExperience())	

		# log experience for player stats.
		sdObjectSetVal("UnitStats", gc.getPlayer(objUnit.getOwner()), EXPERIENCE, sdObjectGetVal("UnitStats", gc.getPlayer(objUnit.getOwner()), EXPERIENCE) + objWinner.getExperience())


		#Generate the log message

		oddsdata = sdObjectGetVal("UnitStats", objUnit, ODDSDATA)

		iCombatOdds = oddsdata[3]
		
		strCombatOdds = str("%.1f%%") %(oddsdata[3])

		strWinnerHealth = str("%.2f") %(int(objWinner.baseCombatStr()) * float(objWinner.currHitPoints()) / float(objWinner.maxHitPoints()))
		baseStrength = str("%.2f") %(objWinner.baseCombatStr())

		victimCivName = objLosingPlayer.getCivilizationAdjective()
			
		# Get the game clock string
		strGameClock = self.getCurrentGameClockString(objWinner.getOwner())

		newCombatMessage = strGameClock + ": " + localText.getText("TXT_KEY_UNITSTATS_KILL", (victimCivName, gc.getUnitInfo(objLoser.getUnitType()).getDescription(), strWinnerHealth, baseStrength, strCombatOdds)) + "\n"

		# log the combat message for the unit.
		self.updateUnitLog(objWinner, newCombatMessage)

		# if this was the luckiest fight of the unit, save the combat odds as the unit's personal high score
		if (iCombatOdds < sdObjectGetVal("UnitStats", objUnit, BESTODDS) or sdObjectGetVal("UnitStats", objUnit, BESTODDS) == -1):
			sdObjectSetVal("UnitStats", objUnit, BESTODDS, iCombatOdds)
			
			#item 2 in the oddsdata list contains a string message that will be displayed on the unit statistics page
			oddsdata[2] = localText.getText("TXT_KEY_UNITSTATS_LUCKIEST_FIGHT", ()) + "\n" + strGameClock + ": " + localText.getText("TXT_KEY_UNITSTATS_KILL", (victimCivName, gc.getUnitInfo(objLoser.getUnitType()).getDescription(), strWinnerHealth, baseStrength, strCombatOdds)) + "\n"

		# store oddsdata list
		sdObjectSetVal("UnitStats", objUnit, ODDSDATA, oddsdata)


		# Check combat high scores
		if (g_bTrackHighScore):
			self.checkHighScoresCurrentUnit([BATTLECOUNT, BODYCOUNT, EXPERIENCE, BESTODDS, LIFEODDS, AVERAGEODDSHIGHEST, AVERAGEODDSLOWEST], objWinner)

			if (g_bGlobalHighScore or not g_bTrackAllPlayers):
				highestoddsunit = sdGetVal("UnitStats", "HighscoreUnits", AVERAGEODDSHIGHEST)
				highestodds = sdGetVal("UnitStats", "Highscores", AVERAGEODDSHIGHEST)
				lowestoddsunit = sdGetVal("UnitStats", "HighscoreUnits", AVERAGEODDSLOWEST)
				lowestodds = sdGetVal("UnitStats", "Highscores", AVERAGEODDSLOWEST)
			else:
				highestoddsunit = sdObjectGetVal("UnitStats", objUnit.getOwner(), "HighscoreUnits", AVERAGEODDSHIGHEST)
				highestodds = sdObjectGetVal("UnitStats", objUnit.getOwner(), "Highscores", AVERAGEODDSHIGHEST)
				lowestoddsunit = sdObjectGetVal("UnitStats", objUnit.getOwner(), "HighscoreUnits", AVERAGEODDSLOWEST)
				lowestodds = sdObjectGetVal("UnitStats", objUnit.getOwner(), "Highscores", AVERAGEODDSLOWEST)

			if (highestoddsunit == UnitID):
				if (sdObjectGetVal("UnitStats", objUnit, AVERAGEODDS) < highestodds):
					self.checkHighScoresAllUnits(AVERAGEODDSHIGHEST, objUnit.getOwner())

			if (lowestoddsunit == UnitID):
				if (sdObjectGetVal("UnitStats", objUnit, AVERAGEODDS) > lowestodds):
					self.checkHighScoresAllUnits(AVERAGEODDSLOWEST, objUnit.getOwner())	

	def onUnitLost(self, argsList):
		'Unit Lost'
		objUnit = argsList[0]
		# Get an ID string that is unique (unit.getID() isn't unique)
		UnitID = str(objUnit.getID()) + "X" + str(objUnit.getOwner())
		objUnitInfo = PyInfo.UnitInfo(objUnit.getUnitType())
		if (g_bTrackAllPlayers or objUnit.getOwner() == gc.getGame().getActivePlayer()):
			
			#if the unit has been named with the default name-generator, its name is stored in the lostnameslist (unique for each unit type) for re-use.
			if (g_iUnitNaming == 1 and g_bUnitNameRecycling):
				unittypeandowner = objUnitInfo.getDescription() + str(objUnit.getOwner())
				if sdEntityExists("UnitStats", unittypeandowner):
					lostnameslist = sdGetVal("UnitStats", unittypeandowner, LOSTNAMESLIST)
					lostnameslist.append(objUnit.getNameNoDesc())
					sdSetVal("UnitStats", unittypeandowner, LOSTNAMESLIST, lostnameslist)

			#if the unit has been named with the nexus name-generator, its name is stored in the lostnameslist (unique for each unit category) for re-use.
			if (g_iUnitNaming == 3 and g_bUnitNameRecycling):
				unitcategory = 0		
				if (objUnit.getUnitClassType() >= 16 and objUnit.getUnitClassType() <= 43):
					unitcategory= 1
				elif (objUnit.getUnitClassType() >= 45 and objUnit.getUnitClassType() <= 54):
					unitcategory= 2
				elif (objUnit.getUnitClassType() >= 55 and objUnit.getUnitClassType() <= 59):
					unitcategory= 3			
				if (unitcategory != 0):			
					unitcategoryandowner = str(unitcategory) + str(objUnit.getOwner())
					lostnameslist = sdGetVal("UnitStats", unitcategoryandowner, LOSTNAMESLIST)
					lostnameslist.append(objUnit.getNameNoDesc())
					sdSetVal("UnitStats", unitcategoryandowner, LOSTNAMESLIST, lostnameslist)

			#this updates the high scores
			highscorelist = HighScoreTypes.keys()
			for htype in highscorelist:
				if (g_bTrackHighScore):
					#if the lost unit had a high score, check for the new high score holder.
					if (g_bGlobalHighScore or not g_bTrackAllPlayers):
						highscoreunit = sdGetVal("UnitStats", "HighscoreUnits", htype)
					else:
						highscoreunit = sdObjectGetVal("UnitStats", objUnit.getOwner(), "HighscoreUnits", htype)
					if (highscoreunit == UnitID):
						if (htype == STARTTURN):
							if (g_bGlobalHighScore or not g_bTrackAllPlayers):
								sdSetVal("UnitStats", "Highscores", htype, 6000)
							else:
								sdObjectSetVal("UnitStats", objUnit.getOwner(), "Highscores", htype, 6000)
							sdObjectSetVal("UnitStats", objUnit, htype, 6000)
							self.checkHighScoresAllUnits(htype, objUnit.getOwner())
						elif (htype == BESTODDS or htype == LIFEODDS):
							if (g_bGlobalHighScore or not g_bTrackAllPlayers):
								sdSetVal("UnitStats", "Highscores", htype, 101)
							else:
								sdObjectSetVal("UnitStats", objUnit.getOwner(), "Highscores", htype, 101)
							sdObjectSetVal("UnitStats", objUnit, htype, 101)
							self.checkHighScoresAllUnits(htype, objUnit.getOwner())
						elif (htype == AVERAGEODDSLOWEST):
							if (g_bGlobalHighScore or not g_bTrackAllPlayers):
								sdSetVal("UnitStats", "Highscores", htype, 101)
							else:
								sdObjectSetVal("UnitStats", objUnit.getOwner(), "Highscores", htype, 101)
							sdObjectSetVal("UnitStats", objUnit, AVERAGEODDS, 101)
							self.checkHighScoresAllUnits(htype, objUnit.getOwner())
						elif (htype == AVERAGEODDSHIGHEST):
							if (g_bGlobalHighScore or not g_bTrackAllPlayers):
								sdSetVal("UnitStats", "Highscores", htype, -1)
							else:
								sdObjectSetVal("UnitStats", objUnit.getOwner(), "Highscores", htype, -1)
							sdObjectSetVal("UnitStats", objUnit, AVERAGEODDS, -1)
							self.checkHighScoresAllUnits(htype, objUnit.getOwner())
						else:
							if (g_bGlobalHighScore or not g_bTrackAllPlayers):
								sdSetVal("UnitStats", "Highscores", htype, 0)
							else:
								sdObjectSetVal("UnitStats", objUnit.getOwner(), "Highscores", htype, 0)
							sdObjectSetVal("UnitStats", objUnit, htype, 0)
							self.checkHighScoresAllUnits(htype, objUnit.getOwner())
							
			sdObjectWipe("UnitStats", objUnit)
	
	# Logs the promotion of a unit
	def logUnitPromotion(self, objUnit, iPromotionID):
		
		
		# Get the promotion information
		objPromotionInfo = gc.getPromotionInfo(iPromotionID)

		# Return immediately if the unit passed in is invalid
		if(objUnit == None):
			return
			
		# Return immediately if the promotion ID passed in is invalid
		if(objPromotionInfo == None):
			return

		# Return immediately if for some reason we haven't been logging the 
		# unit. TODO: Maybe this condition should be handled differently?
		if(sdObjectExists("UnitStats", objUnit) == False):
			return
			
		# Get the game clock string
		strGameClock = self.getCurrentGameClockString(objUnit.getOwner())
				
		# Construct the unit promotion message
		newPromoMessage = strGameClock + ": " + localText.getText("TXT_KEY_UNITSTATS_PROMOTION", (objPromotionInfo.getDescription(), ())) + "\n"

		# log the promotion message for the unit.
		self.updateUnitLog(objUnit, newPromoMessage)


	# this function is called when a unit is hit
	# iTrack = 0: attacker's and defender's stats are updated.
	# iTrack = 1: only attacker's stats are updated
	# iTrack = 2: only defender's stats are updated
	def onCombatHit(self, argsList, iTrack):
		'Combat Message'

		genericArgs = argsList[0][0]

		attackerUnit = genericArgs[0]
		defenderUnit = genericArgs[1]
		iIsAttacker = genericArgs[2]
		iDamage = genericArgs[3]

		# The numbers in the UpdateList signify the stats that are being updated:
		# 0: damage inflicted
		# 1: damage inflicted while attacking
		# 2: damage inflicted while defending
		# 3: damage suffered
		# 4: damage suffered while attacking
		# 5: damage suffered while defending
		# 6: collateral damage inflicted
		# 7: collateral damage suffered
		# 8: air strike damage inflicted
		# 9: air strike damage suffered
		attackerUpdateList = []
		defenderUpdateList = []
			
		#if the attacking unit is hurt, calculate the damage and define which unit statistics are updated
		if (iIsAttacker == 1):
		
			# Get the damage
			damage = iDamage * float(attackerUnit.baseCombatStr()) / float(attackerUnit.maxHitPoints())
	
			if (iTrack == 0 or iTrack == 1):
				attackerUpdateList.append(3)
		 		attackerUpdateList.append(4)
			if (iTrack == 0 or iTrack == 2):
				defenderUpdateList.append(0)
				defenderUpdateList.append(2)
								
		#if the defending unit is hurt, calculate the damage and define which unit statistics are updated				
		if (iIsAttacker == 0):
			
			# Get the damage
			damage = iDamage * float(defenderUnit.baseCombatStr()) / float(defenderUnit.maxHitPoints())	

			if (iTrack == 0 or iTrack == 1):
				attackerUpdateList.append(0)
		 		attackerUpdateList.append(1)
			if (iTrack == 0 or iTrack == 2):
				defenderUpdateList.append(3)
				defenderUpdateList.append(5)
		
		# Updates the attacker's stat if necessary
		if (len(attackerUpdateList) > 0 and (iTrack == 0 or iTrack == 1)):

			self.damageUpdater(attackerUnit, attackerUpdateList, damage)
			
		# Updates the defender's stat if necessary
		if (len(defenderUpdateList) > 0 and (iTrack == 0 or iTrack == 2)):
			
			self.damageUpdater(defenderUnit, defenderUpdateList, damage)

		if (iIsAttacker == 1):
			# If the attacker dies, update the owner's loss count
			if (attackerUnit.currHitPoints() <= 0 and (iTrack == 0 or iTrack == 1)):
				self.combatcountUpdater(None, ATTACK, 2, attackerUnit.getOwner())

				
			# If the defender wins, check the new combat high scores
			if (attackerUnit.currHitPoints() <= 0 and (iTrack == 0 or iTrack == 2)):
				self.combatcountUpdater(defenderUnit, DEFENCE, 1, defenderUnit.getOwner())
				if (g_bTrackHighScore):
					self.checkHighScoresCurrentUnit([DAMAGETYPE[0], DAMAGETYPE[2], DAMAGETYPE[3], DAMAGETYPE[5]], defenderUnit)

		if (iIsAttacker == 0):	
			# If the defender dies, update the owner's loss count
			if (defenderUnit.currHitPoints() <= 0 and (iTrack == 0 or iTrack == 2)):
				self.combatcountUpdater(None, DEFENCE, 2, defenderUnit.getOwner())

				
			# If the attacker wins, check the new combat high scores
			if (defenderUnit.currHitPoints() <= 0 and (iTrack == 0 or iTrack == 1)):
				self.combatcountUpdater(attackerUnit, ATTACK, 1, attackerUnit.getOwner())
				if (g_bTrackHighScore):
					self.checkHighScoresCurrentUnit([DAMAGETYPE[0], DAMAGETYPE[1], DAMAGETYPE[3], DAMAGETYPE[4]], attackerUnit)


	# this function is called when an air unit is intercepted
	# iTrack = 0: attacker's and interceptor's stats are updated.
	# iTrack = 1: only attacker's stats are updated
	# iTrack = 2: only interceptor's stats are updated
	def onAirIntercept(self, argsList, iTrack):
		'Combat Message'

		genericArgs = argsList[0][0]

		attackerUnit = genericArgs[0]
		interceptorUnit = genericArgs[1]
		iIsAttacker = genericArgs[2]
		iDamage = genericArgs[3]

		# The numbers in the UpdateList signify the stats that are being updated:
		# 0: damage inflicted
		# 1: damage inflicted while attacking
		# 2: damage inflicted while defending
		# 3: damage suffered
		# 4: damage suffered while attacking
		# 5: damage suffered while defending
		# 6: collateral damage inflicted
		# 7: collateral damage suffered
		# 8: air strike damage inflicted
		# 9: air strike damage suffered
		attackerUpdateList = []
		interceptorUpdateList = []

		# Updates the units' battle count
		if(iTrack == 0 or iTrack == 2):
			self.combatcountUpdater(interceptorUnit, AIRDEFENCE, 0, interceptorUnit.getOwner())				
		if(iTrack == 0 or iTrack == 1):
			self.combatcountUpdater(attackerUnit, AIRATTACK, 0, attackerUnit.getOwner())				

			
		#if the attacking unit is hurt, calculate the damage and define which unit statistics are updated
		if (iIsAttacker == 1):
			
			# Get the damage
			damage = iDamage * float(attackerUnit.airBaseCombatStr()) / float(attackerUnit.maxHitPoints())

			if (iTrack == 0 or iTrack == 1):
				attackerUpdateList.append(3)
		 		attackerUpdateList.append(4)
			if (iTrack == 0 or iTrack == 2):
				interceptorUpdateList.append(0)
				interceptorUpdateList.append(2)
								
		#if the intercepting unit is hurt, calculate the damage and define which unit statistics are updated				
		if (iIsAttacker == 0):
			# Get the damage
			damage = iDamage * float(interceptorUnit.airBaseCombatStr()) / float(interceptorUnit.maxHitPoints())

			if (iTrack == 0 or iTrack == 1):
				attackerUpdateList.append(0)
		 		attackerUpdateList.append(1)
			if (iTrack == 0 or iTrack == 2):
				interceptorUpdateList.append(3)
				interceptorUpdateList.append(5)
		
		# Updates the attacker's stat if necessary
		if (len(attackerUpdateList) > 0 and (iTrack == 0 or iTrack == 1)):

			self.damageUpdater(attackerUnit, attackerUpdateList, damage)
			
		# Updates the defender's stat if necessary
		if (len(interceptorUpdateList) > 0 and (iTrack == 0 or iTrack == 2)):
			
			self.damageUpdater(interceptorUnit, interceptorUpdateList, damage)

		if (iIsAttacker == 1):
			# If the attacker dies, update the owner's loss count
			if (attackerUnit.currHitPoints() <= 0 and (iTrack == 0 or iTrack == 1)):
				self.combatcountUpdater(None, AIRATTACK, 2, attackerUnit.getOwner())

				
			# If the interceptor wins, check the new combat high scores
			if (attackerUnit.currHitPoints() <= 0 and (iTrack == 0 or iTrack == 2)):
				self.combatcountUpdater(interceptorUnit, AIRDEFENCE, 1, interceptorUnit.getOwner())
				if (g_bTrackHighScore):
					self.checkHighScoresCurrentUnit([DAMAGETYPE[0], DAMAGETYPE[2], DAMAGETYPE[3], DAMAGETYPE[5]], interceptorUnit)


				# Add a message to the unit log
				strWinnerHealth = str("%.2f") %(int(interceptorUnit.airBaseCombatStr()) * float(interceptorUnit.currHitPoints()) / float(interceptorUnit.maxHitPoints()))
				objLosingPlayer = PyPlayer(attackerUnit.getOwner())
				victimCivName = objLosingPlayer.getCivilizationAdjective()		
				# Get the game clock string
				strGameClock = self.getCurrentGameClockString(interceptorUnit.getOwner())
				baseStrength = str("%.2f") %(interceptorUnit.airBaseCombatStr())

				newCombatMessage = strGameClock + ": " + localText.getText("TXT_KEY_UNITSTATS_KILL", (victimCivName, gc.getUnitInfo(attackerUnit.getUnitType()).getDescription(), iWinnerHealth, baseStrength)) + "\n"
				# log the combat message for the unit.
				self.updateUnitLog(interceptorUnit, newCombatMessage)


		if (iIsAttacker == 0):	
			# If the interceptor dies, update the owner's loss count
			if (interceptorUnit.currHitPoints() <= 0 and (iTrack == 0 or iTrack == 2)):
				self.combatcountUpdater(None, AIRDEFENCE, 2, interceptorUnit.getOwner())

				
			# If the attacker wins, check the new combat high scores
			if (interceptorUnit.currHitPoints() <= 0 and (iTrack == 0 or iTrack == 1)):
				self.combatcountUpdater(attackerUnit, AIRATTACK, 1, attackerUnit.getOwner())
				if (g_bTrackHighScore):
					self.checkHighScoresCurrentUnit([DAMAGETYPE[0], DAMAGETYPE[1], DAMAGETYPE[3], DAMAGETYPE[4]], attackerUnit)

				# Add a message to the unit log
				iWinnerHealth = str("%.2f") %(int(attackerUnit.airBaseCombatStr()) * float(attackerUnit.currHitPoints()) / float(attackerUnit.maxHitPoints()))
				baseStrength = str("%.2f") %(attackerUnit.airBaseCombatStr())
				objLosingPlayer = PyPlayer(interceptorUnit.getOwner())
				victimCivName = objLosingPlayer.getCivilizationAdjective()	

				# Get the game clock string
				strGameClock = self.getCurrentGameClockString(attackerUnit.getOwner())
				newCombatMessage = strGameClock + ": " + localText.getText("TXT_KEY_UNITSTATS_KILL", (victimCivName, gc.getUnitInfo(interceptorUnit.getUnitType()).getDescription(), strWinnerHealth, baseStrength)) + "\n"
				# log the combat message for the unit.
				self.updateUnitLog(attackerUnit, newCombatMessage)


	
	# this function is called when collateral damage is inflicted
	# iTrack = 0: attacker's and defender's stats are updated.
	# iTrack = 1: only attacker's stats are updated
	# iTrack = 2: only defender's stats are updated
	def onCollateralHit(self, argsList, iTrack):
		'Combat Message'

		genericArgs = argsList[0][0]

		attackerUnit = genericArgs[0]
		defenderUnit = genericArgs[1]
		iDamage = genericArgs[2]

		# The numbers in the UpdateList signify the stats that are being updated:
		# 0: damage inflicted
		# 1: damage inflicted while attacking
		# 2: damage inflicted while defending
		# 3: damage suffered
		# 4: damage suffered while attacking
		# 5: damage suffered while defending
		# 6: collateral damage inflicted
		# 7: collateral damage suffered
		# 8: air strike damage inflicted
		# 9: air strike damage suffered
		attackerUpdateList = []
		defenderUpdateList = []
			
								
		#if the defending unit is hurt, calculate the damage and define which unit statistics are updated				
		damage = iDamage * float(defenderUnit.baseCombatStr()) / float(defenderUnit.maxHitPoints())	
		if (iTrack == 0 or iTrack == 1):
			attackerUpdateList.append(0)
			attackerUpdateList.append(6)
		if (iTrack == 0 or iTrack == 2):
			defenderUpdateList.append(3)
			defenderUpdateList.append(7)
		
		# Updates the attacker's stat if necessary
		if (len(attackerUpdateList) > 0 and (iTrack == 0 or iTrack == 1)):

			self.damageUpdater(attackerUnit, attackerUpdateList, damage)
			
		# Updates the defender's stat if necessary
		if (len(defenderUpdateList) > 0 and (iTrack == 0 or iTrack == 2)):
			
			self.damageUpdater(defenderUnit, defenderUpdateList, damage)

		if (g_bTrackHighScore):
			if (iTrack == 0 or iTrack == 1):
				self.checkHighScoresCurrentUnit([DAMAGETYPE[6]], attackerUnit)
			if (iTrack == 0 or iTrack == 2):
				self.checkHighScoresCurrentUnit([DAMAGETYPE[7]], defenderUnit)

	# this function is called when collateral damage is inflicted
	# iTrack = 0: attacker's and defender's stats are updated.
	# iTrack = 1: only attacker's stats are updated
	# iTrack = 2: only defender's stats are updated
	def onAirStrikeHit(self, argsList, iTrack):
		'Combat Message'

		genericArgs = argsList[0][0]

		attackerUnit = genericArgs[0]
		defenderUnit = genericArgs[1]
		iDamage = genericArgs[2]

		# The numbers in the UpdateList signify the stats that are being updated:
		# 0: damage inflicted
		# 1: damage inflicted while attacking
		# 2: damage inflicted while defending
		# 3: damage suffered
		# 4: damage suffered while attacking
		# 5: damage suffered while defending
		# 6: collateral damage inflicted
		# 7: collateral damage suffered
		# 8: air strike damage inflicted
		# 9: air strike damage suffered
		attackerUpdateList = []
		defenderUpdateList = []
			
								
		#if the defending unit is hurt, calculate the damage and define which unit statistics are updated				
		damage = iDamage * float(defenderUnit.baseCombatStr()) / float(defenderUnit.maxHitPoints())	
		if (iTrack == 0 or iTrack == 1):
			attackerUpdateList.append(0)
			attackerUpdateList.append(8)
		if (iTrack == 0 or iTrack == 2):
			defenderUpdateList.append(3)
			defenderUpdateList.append(9)
		
		# Updates the attacker's stat if necessary
		if (len(attackerUpdateList) > 0 and (iTrack == 0 or iTrack == 1)):

			self.combatcountUpdater(attackerUnit, AIRSTRIKE, 0, attackerUnit.getOwner())

			self.damageUpdater(attackerUnit, attackerUpdateList, damage)
			
		# Updates the defender's stat if necessary
		if (len(defenderUpdateList) > 0 and (iTrack == 0 or iTrack == 2)):

			self.combatcountUpdater(defenderUnit, AIRSTRIKE, 1, defenderUnit.getOwner())
			
			self.damageUpdater(defenderUnit, defenderUpdateList, damage)

		if (g_bTrackHighScore):
			if (iTrack == 0 or iTrack == 1):
				self.checkHighScoresCurrentUnit([DAMAGETYPE[8]], attackerUnit)
			if (iTrack == 0 or iTrack == 2):
				self.checkHighScoresCurrentUnit([DAMAGETYPE[9]], defenderUnit)


	# this function is called when a unit withdraws from combat
	# iTrack = 0: attacker's and defender's stats are updated.
	# iTrack = 1: only attacker's stats are updated
	# iTrack = 2: only defender's stats are updated
	def onCombatWithdrawal(self, argsList, iTrack):
		'Combat Message'

		genericArgs = argsList[0][0]

		attackerUnit = genericArgs[0]
		defenderUnit = genericArgs[1]


		# Adds a message to the attacker's (withdrawer's) log
		if (iTrack == 0 or iTrack == 1):

			self.combatcountUpdater(attackerUnit, ATTACK, 3, attackerUnit.getOwner())

			oddsdata = sdObjectGetVal("UnitStats", attackerUnit, ODDSDATA)
		
			combatodds = str("%.1f%%") %(oddsdata[3])
	
			strAttackerHealth = str("%.2f") %(int(attackerUnit.baseCombatStr()) * float(attackerUnit.currHitPoints()) / float(attackerUnit.maxHitPoints()))
			strBaseStrength = str("%.2f") %(attackerUnit.baseCombatStr())

			objDefendingPlayer = PyPlayer(defenderUnit.getOwner())

			defenderCivName = objDefendingPlayer.getCivilizationAdjective()
			
			# Get the game clock string
			strGameClock = self.getCurrentGameClockString(attackerUnit.getOwner())

			newWithdrawalMessage = strGameClock + ": " + localText.getText("TXT_KEY_UNITSTATS_OWN_WITHDRAWAL", (defenderCivName, gc.getUnitInfo(defenderUnit.getUnitType()).getDescription(), strAttackerHealth, strBaseStrength, combatodds)) + "\n"

			# log the combat message for the unit.
			self.updateUnitLog(attackerUnit, newWithdrawalMessage)

		# Adds a message to the defender's log
		if (iTrack == 0 or iTrack == 2):

			self.combatcountUpdater(defenderUnit, DEFENCE, 3, defenderUnit.getOwner())

			oddsdata = sdObjectGetVal("UnitStats", defenderUnit, ODDSDATA)
		
			combatodds = str("%.1f%%") %(oddsdata[3])
	
			strDefenderHealth = str("%.2f") %(int(defenderUnit.baseCombatStr()) * float(defenderUnit.currHitPoints()) / float(defenderUnit.maxHitPoints()))
			strBaseStrength = str("%.2f") %(defenderUnit.baseCombatStr())

			objAttackingPlayer = PyPlayer(attackerUnit.getOwner())

			attackerCivName = objAttackingPlayer.getCivilizationAdjective()
					
			# Get the game clock string
			strGameClock = self.getCurrentGameClockString(defenderUnit.getOwner())

			newWithdrawalMessage = strGameClock + ": " + localText.getText("TXT_KEY_UNITSTATS_ENEMY_WITHDRAWAL", (attackerCivName, gc.getUnitInfo(attackerUnit.getUnitType()).getDescription(), strDefenderHealth, strBaseStrength, combatodds)) + "\n"

			# log the combat message for the unit.
			self.updateUnitLog(defenderUnit, newWithdrawalMessage)

			# Check some high scores
			if (g_bTrackHighScore):
				self.checkHighScoresCurrentUnit([BATTLECOUNT, LIFEODDS], attackerUnit)
				
	def onCombatBegin(self, argsList):
		'Combat Result'	

		genericArgs = argsList[0][0]

		attackerUnit = genericArgs[0]
		defenderUnit = genericArgs[1]
		iDefenderOdds = genericArgs[2]

		Unitl = []
		
		if(g_bTrackAllPlayers or attackerUnit.getOwner() == gc.getGame().getActivePlayer()):
			Unitl.append(attackerUnit)
			
		if(g_bTrackAllPlayers or defenderUnit.getOwner() == gc.getGame().getActivePlayer()):
			Unitl.append(defenderUnit)
			
		# If at least one unit is to be updated, do the whole loop for each unit that has to be updated.
		if (len(Unitl) > 0):
			for objUnit in Unitl:
				
				UnitID = str(objUnit.getID())+ "X" + str(objUnit.getOwner())

				if (objUnit == attackerUnit):
					combatodds = iDefenderOdds/10.0
					self.combatcountUpdater(objUnit, ATTACK, 0, objUnit.getOwner())
			
				elif (objUnit == defenderUnit):
					combatodds = 100 - iDefenderOdds/10.0
					self.combatcountUpdater(objUnit, DEFENCE, 0, objUnit.getOwner())

				# get the data for the average odds and the message string displayed
				oddsdata = sdObjectGetVal("UnitStats", objUnit, ODDSDATA)
		
				#item 0 in the oddsdata list is the additive amount of all combat odds
				oddsdata[0] = oddsdata[0] + combatodds
		
				#item 1 in the oddsdata list is the number of fights so far. item 0 / item 1 = average odds
				oddsdata[1] = oddsdata[1] + 1
				
				oddsdata[3] = combatodds

				# store average odds
				sdObjectSetVal("UnitStats", objUnit, AVERAGEODDS, oddsdata[0] / oddsdata[1])
				
				# store oddsdata list
				sdObjectSetVal("UnitStats", objUnit, ODDSDATA, oddsdata)

				# Get the probability that your unit survives.
				lifeodds = sdObjectGetVal("UnitStats", objUnit, LIFEODDS)
				if (objUnit == attackerUnit):
					print objUnit.withdrawalProbability()
					lifeodds = lifeodds * (combatodds + (100 - combatodds) * objUnit.withdrawalProbability() / 100) / 100
				elif (objUnit == defenderUnit):
					lifeodds = lifeodds * combatodds / 100		
				sdObjectSetVal("UnitStats", objUnit, LIFEODDS, lifeodds)
	


	# Returns a combination of the current game turn/year depending on the 
	# INI file configuration		
	def getCurrentGameClockString(self, iPlayerID):
		strGameClock = ""
		
		objPlayer = gc.getPlayer(iPlayerID)
		
		# if the player ID passed in is invalid then return only the game turn 
		# regardless if the turn information has been turned off or not.
		
		strTurn = localText.getText("TXT_KEY_UNITSTATS_TURN", ())
		
		if(objPlayer == None):
			return strTurn + " " + gc.getGame().getGameTurn()
			
		# Get the current game turn
		strCurrentTurn = gc.getGame().getGameTurn()

		# Get the current game year
		strCurrentYear = CyGameTextMgr().getInterfaceTimeStr(iPlayerID)			

		if(g_bShowLogTurnInformation and g_bShowLogDateInformation):
			if(g_bShowLogTurnInformationFirst):
				strGameClock = strTurn + " %s (%s)" %(strCurrentTurn, strCurrentYear)
			else:
				strGameClock = "%s (" + strTurn + " %s)" %(strCurrentYear, strCurrentTurn)
		elif(g_bShowLogTurnInformation and not g_bShowLogDateInformation):
				strGameClock = strTurn + " %s" %(strCurrentTurn)
		elif(not g_bShowLogTurnInformation and g_bShowLogDateInformation):
				strGameClock = "%s" %(strCurrentYear)
		else:
			strGameClock = strTurn  +" %s (%s)" %(strCurrentTurn, strCurrentYear)
		
		return strGameClock
		
		
	# Returns the next unit name for the given unit type.
	def getNextUnitName(self, objUnit):
		' strUnitName - the next possible name for the given unit type.'
		
		objUnitInfo = PyInfo.UnitInfo(objUnit.getUnitType())
		strUnitName = None
	
		# Return None if the unit type ID passed in is invalid
		if(objUnit == None):
			return strUnitName

		# Returns if the Name Generator is disabled	
		iUnitTypeCount = 0
		if (g_iUnitNaming == 0):
			return
		
		#starts the built-in Name Generator (Warrior 1, Warrior2...)
		elif (g_iUnitNaming == 1):
			
			# If the unit type information doesn't exist then create it
			unittypeandowner = objUnitInfo.getDescription() + str(objUnit.getOwner())
			if(sdEntityExists("UnitStats", unittypeandowner) == False):

				unitTypeDictionary = { TYPENUMBER : iUnitTypeCount, 
									  				LOSTNAMESLIST: []
									  				}
							
				sdEntityInit("UnitStats", unittypeandowner, unitTypeDictionary)
			
			# if Unit Name Recycling is enabled, we'll check if we have already lost a unit of this type. if we have, re-use the name
			
			if (g_bUnitNameRecycling):		
				lostnameslist = sdGetVal("UnitStats", unittypeandowner, LOSTNAMESLIST)
			
				if (len(lostnameslist) > 0):
				
					#we want to get Warrior 1 before Warrior 2, even if Warrior 2 died first.
					lostnameslistsorted = Numsort.sorted_copy(lostnameslist)
				
					#the unit gets the lowest number possible
					strUnitName = lostnameslistsorted[0]
				
					#the name is deleted from the list, so that it is not used again
					del lostnameslistsorted[0]			
					sdSetVal("UnitStats", unittypeandowner, LOSTNAMESLIST, lostnameslistsorted)
				
					return strUnitName
			
			iUnitTypeCount = sdGetVal("UnitStats", unittypeandowner, TYPENUMBER) + 1

			# Save the new unit type count
			sdSetVal("UnitStats", unittypeandowner, TYPENUMBER, iUnitTypeCount)

			# Build the new unit name
			strUnitName = objUnitInfo.getDescription() + " " + str(iUnitTypeCount)
			
			return strUnitName
		
		# Returns a name with the Random Name Generator
		
		elif (g_iUnitNaming == 2):	
			objUnit.setName(RandomNameUtils.getRandomCivilizationName(objUnit.getCivilizationType()))
			
		elif (g_iUnitNaming == 3):
			unitcategory = 0		

			if (objUnit.getUnitClassType() >= 16 and objUnit.getUnitClassType() <= 43):
				unitcategory= 1

			elif (objUnit.getUnitClassType() >= 45 and objUnit.getUnitClassType() <= 54):
				unitcategory= 2

			elif (objUnit.getUnitClassType() >= 55 and objUnit.getUnitClassType() <= 59):
				unitcategory= 3			
			
			if (unitcategory != 0):	
				unitcategoryandowner = str(unitcategory) + str(objUnit.getOwner())
				if(sdEntityExists("UnitStats", unitcategoryandowner) == False):

					unitTypeDictionary = { LOSTNAMESLIST: [] }
									  									
					sdEntityInit("UnitStats", unitcategoryandowner, unitTypeDictionary)
			
				# if Unit Name Recycling is enabled, we'll check if we have already lost a unit of this type. if we have, re-use the name
			
				if (g_bUnitNameRecycling):
			
					lostnameslist = sdGetVal("UnitStats", unitcategoryandowner, LOSTNAMESLIST)
			
					#if we have lost a unit of this type, re-use its name
			
					if (len(lostnameslist) > 0):
				
						#we want to get Warrior 1 before Warrior 2, even if Warrior 2 died first.
						lostnameslist.sort()
				
						#the unit gets the lowest number possible
						strUnitName = lostnameslist[0]
				
						#the name is deleted from the list, so that it is not used again
						del lostnameslist[0]			
						sdSetVal("UnitStats", unitcategoryandowner, LOSTNAMESLIST, lostnameslist)
				
						return strUnitName
			
			strUnitName = NexusNameUtils.getNexusName(objUnit)		
			return strUnitName	
	
	
	# Updates the log for objUnit with the message
	# passed in through strNewMessage. Returns true if the log was successfully 
	# updated false otherwise
	def updateUnitLog(self, objUnit, strNewMessage):
		' boolean - Returns true if the log was successfully updated false otherwise.'
		
		# Return false immediately if an invalid unit was passed in
		if(objUnit == None):
			return false
						
		# Return false immediately if an invalid new message was passed in
		if(strNewMessage == None):
			return false
			
		# Return false immediately if an empty message was passed in
		if(len(strNewMessage) == 0):
			return false
		
		# Return false immediately if for some reason we haven't been logging
		# the unit. TODO: Maybe this condition should be handled differently?
		if(sdObjectExists("UnitStats", objUnit) == False):
			return false
			
		# Get the units current log
		strUnitLog = sdObjectGetVal("UnitStats", objUnit, LIST)

		# Add the new message to the unit log
		strUnitLog = strUnitLog + strNewMessage

		# Save the updated unit log.
		sdObjectSetVal("UnitStats", objUnit, LIST, strUnitLog)
		
		return true		
	
	#still needed for reference from CvUnistStatisticsEventManager.py	
	def setupUnitStats(self, objUnit):	

		if (sdObjectExists("UnitStats", objUnit) == false):
			sdObjectInit("UnitStats", objUnit, UnitStatsData)
		
		if(sdObjectExists("UnitStats", gc.getPlayer(objUnit.getOwner())) == False):
			sdObjectInit("UnitStats", gc.getPlayer(objUnit.getOwner()), PlayerStatsData)

		
	# Updates a dictionary in which the number of battles, wins and losses is stored	
	def combatcountUpdater(self, objUnit, AttDef, iType, iOwner):
	
			
		# The combatcount dictionary looks like this: {ATTACK: [iBattles, iKills, iLosses, iWithdrawals], DEFENCE: [iBattles, iKills, iLosses, iWithdrawals], AIRATTACK: [iBattles, iKills, iLosses], AIRDEFENCE: [iBattles, iKills, iLosses], AIRSTRIKE: [iAttacks, iDefences]}
		# combatcount[ATTACK][1] is thus the number of kills in attacks, (combatcount[ATTACK][1] + combatcount[DEFENCE][1]) the total number of kills		
		if (objUnit != None):
			#updates dictionary for unit
			combatcount = sdObjectGetVal("UnitStats", objUnit, COMBATCOUNT)
			combatcount[AttDef][iType] = combatcount[AttDef][iType] + 1
			sdObjectSetVal("UnitStats", objUnit, COMBATCOUNT, combatcount)	
			
		#updates dictionary for player
		combatcount = sdObjectGetVal("UnitStats", gc.getPlayer(iOwner), COMBATCOUNT)
		combatcount[AttDef][iType] = combatcount[AttDef][iType] + 1
		sdObjectSetVal("UnitStats", gc.getPlayer(iOwner), COMBATCOUNT, combatcount)


	# Updates the damage stats for a unit
	def damageUpdater(self, objUnit, updateList, damage):
		
		# Load the player damage stats
		damagestatsplayer = sdObjectGetVal("UnitStats", gc.getPlayer(objUnit.getOwner()), DAMAGESTATS)

		# Load the unit damage stats
		if(objUnit != None):
			damagestatsunit = sdObjectGetVal("UnitStats", objUnit, DAMAGESTATS)

		for updatestat in updateList:
			
			# Updates player damage stat
			damagestatsplayer[updatestat] = damagestatsplayer[updatestat] + damage

			# Updates unit damage stat
			if (objUnit != None):
				damagestatsunit[updatestat] = damagestatsunit[updatestat] + damage

		# Stores unit damage stats
		if (objUnit != None):
			sdObjectSetVal("UnitStats", objUnit, DAMAGESTATS, damagestatsunit)

		# Stores player damage stats
		sdObjectSetVal("UnitStats", gc.getPlayer(objUnit.getOwner()), DAMAGESTATS, damagestatsplayer)
